SystemOrganization addCategory: #SwaUtil!
SystemOrganization addCategory: #'SwaUtil-Collections'!
SystemOrganization addCategory: #'SwaUtil-Events'!
SystemOrganization addCategory: #'SwaUtil-Text'!
SystemOrganization addCategory: #'SwaUtil-Widgets'!
SystemOrganization addCategory: #'SwaUtil-Widgets-Support'!

!HandMorph methodsFor: '*swautil-events-override' stamp: 'mt 4/16/2010 14:08:32.515'!
generateKeyboardEvent: evtBuf
	"Generate the appropriate mouse event for the given raw event buffer"

	| buttons modifiers type pressType stamp char |
	stamp := evtBuf second.
	stamp = 0 ifTrue: [stamp := Time millisecondClockValue].
	pressType := evtBuf fourth.
	pressType = EventKeyDown ifTrue: [type := #keyDown].
	pressType = EventKeyUp ifTrue: [type := #keyUp].
	pressType = EventKeyChar ifTrue: [type := #keystroke].
	modifiers := evtBuf fifth.
	buttons := modifiers bitShift: 3.
	char := self keyboardInterpreter nextCharFrom: Sensor firstEvt: evtBuf.
	
	(type = #keystroke and: [(buttons anyMask: 16) 
			and: [char asciiValue = 30 or: [char asciiValue = 31]]])
		ifTrue: [^ SwaMouseWheelEvent new 
					setType: #mouseWheel
					position: lastMouseEvent cursorPoint
					direction: (char asciiValue = 30 ifTrue: [#up] ifFalse: [#down])
					buttons: buttons
					hand: self
					stamp: stamp].	
	
	^ KeyboardEvent new
		setType: type
		buttons: buttons
		position: self position
		keyValue: char asciiValue
		hand: self
		stamp: stamp.
! !

MorphicModel subclass: #SwaComboBox
	instanceVariableNames: 'contentMorph listMorph buttonMorph list listSelectionIndex getListSelector getIndexSelector setIndexSelector useSelectionIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Widgets'!

!SwaComboBox commentStamp: 'mt 4/5/2010 18:12:19' prior: 0!
Based on DropListMorph from Polymorph package.!

!SwaComboBox class methodsFor: 'instance creation' stamp: 'mt 4/5/2010 18:56:29'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel

	^ self
		on: anObject
		list: getListSel
		selected: getSelectionSel
		changeSelected: setSelectionSel
		useIndex: true! !

!SwaComboBox class methodsFor: 'instance creation' stamp: 'mt 4/5/2010 18:55:54'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel useIndex: useIndex
	"Answer a new instance of the receiver on the given model using
	the given selectors as the interface."

	| instance |
	instance := self new.
	
	getListSel isSymbol
		ifTrue: [instance  getListSelector: getListSel]
		ifFalse: [instance list: getListSel]. "allow direct list"
	
	instance
		model: anObject;
		getIndexSelector: getSelectionSel;
		setIndexSelector: setSelectionSel;
		updateList;
		updateListSelectionIndex;
		updateContents.

	^ instance! !

!SwaComboBox methodsFor: 'geometry' stamp: 'mt 4/5/2010 18:27:54'!
buttonExtent
	
	^ self buttonWidth @ self buttonHeight! !

!SwaComboBox methodsFor: 'geometry' stamp: 'mt 4/5/2010 18:27:36'!
buttonHeight
	
	^ 16! !

!SwaComboBox methodsFor: 'user interface' stamp: 'mt 4/5/2010 18:25:52'!
buttonLabel
	"Answer the label for the button."

	^ ImageMorph new
		image: (ScrollBar
			arrowOfDirection: #bottom
			size: self buttonWidth - 3
			color: self color darker)! !

!SwaComboBox methodsFor: 'accessing' stamp: 'mt 4/5/2010 18:29:26'!
buttonMorph

	^ buttonMorph! !

!SwaComboBox methodsFor: 'accessing' stamp: 'mt 4/5/2010 18:29:26'!
buttonMorph: anObject

	buttonMorph := anObject.! !

!SwaComboBox methodsFor: 'geometry' stamp: 'mt 4/5/2010 19:13:13'!
buttonWidth
	"Answer based on scrollbar size."
	
	^ 16! !

!SwaComboBox methodsFor: 'accessing' stamp: 'mt 4/5/2010 18:29:25'!
contentMorph

	^ contentMorph! !

!SwaComboBox methodsFor: 'accessing' stamp: 'mt 4/5/2010 18:29:25'!
contentMorph: anObject

	contentMorph := anObject.! !

!SwaComboBox methodsFor: 'user interface' stamp: 'mt 4/5/2010 18:37:10'!
font
	"Answer the list font"

	^self listMorph font! !

!SwaComboBox methodsFor: 'user interface' stamp: 'mt 4/5/2010 18:37:21'!
font: aFont
	"Set the list and content font"

	self listMorph font: aFont.
	self contentMorph beAllFont: aFont! !

!SwaComboBox methodsFor: 'model access' stamp: 'mt 4/5/2010 18:38:00'!
getCurrentSelection
	"Answer the current selection from the model."

	|selection|
	selection := self model perform: self getIndexSelector.
	^(self list includes: selection)
		ifTrue: [selection]! !

!SwaComboBox methodsFor: 'model access' stamp: 'mt 4/5/2010 18:38:10'!
getCurrentSelectionIndex
	"Answer the index of the current selection."

	self getIndexSelector ifNil: [^0].
	^self model perform: self getIndexSelector! !

!SwaComboBox methodsFor: 'accessing' stamp: 'mt 4/5/2010 18:29:26'!
getIndexSelector

	^ getIndexSelector! !

!SwaComboBox methodsFor: 'accessing' stamp: 'mt 4/5/2010 18:29:26'!
getIndexSelector: anObject

	getIndexSelector := anObject.! !

!SwaComboBox methodsFor: 'accessing' stamp: 'mt 4/5/2010 18:29:26'!
getListSelector

	^ getListSelector! !

!SwaComboBox methodsFor: 'accessing' stamp: 'mt 4/5/2010 18:29:26'!
getListSelector: anObject

	getListSelector := anObject.! !

!SwaComboBox methodsFor: 'event handling' stamp: 'mt 4/5/2010 18:38:36'!
handlesKeyboard: evt
	"Return true if the receiver wishes to handle the given keyboard event."
	
	^true! !

!SwaComboBox methodsFor: 'visibility' stamp: 'mt 4/6/2010 19:28:32.045'!
hideList
	"Hide the list."

	self listMorph ifNil: [^self].
	self listVisible ifFalse: [^self].
	self listMorph delete.
	self listMorph selectionIndex = self listSelectionIndex
		ifFalse: [self listMorph changeModelSelection: self listMorph selectionIndex].
	self changed.! !

!SwaComboBox methodsFor: 'initialization' stamp: 'mt 4/5/2010 19:18:09'!
initialize
	"Initialize the receiver."

	super initialize.
	listSelectionIndex := 0.
	
	list := #().
	self
		useSelectionIndex: true;
		clipSubmorphs: true;
		layoutPolicy: SwaRowLayout new;
		layoutInset: 2;
		cellPositioning: #center;
		color: Color white;
		cornerStyle: #square;
		listMorph: self newListMorph;
		contentMorph: self newContentMorph;
		buttonMorph: self newButtonMorph;
		borderStyle: BorderStyle default;
		addMorphBack: self contentMorph;
		addMorphBack: (self addDependent: self buttonMorph);
		on: #mouseDown send: #popList to: self;
		height: 22.! !

!SwaComboBox methodsFor: 'event handling' stamp: 'mt 4/5/2010 18:40:16'!
keyStroke: event
	"Pass on to the list."
	
	self listMorph keyStroke: event ! !

!SwaComboBox methodsFor: 'accessing' stamp: 'mt 4/5/2010 18:29:26'!
list

	^ list! !

!SwaComboBox methodsFor: 'accessing' stamp: 'mt 4/5/2010 18:40:53'!
list: aCollection

	list := aCollection.
	self changed: #list.! !

!SwaComboBox methodsFor: 'geometry' stamp: 'mt 4/5/2010 18:41:28'!
listHeight
	"Answer the height for the list."

	^ (self listMorph listMorph height + 6 max: 38) min: 200! !

!SwaComboBox methodsFor: 'accessing' stamp: 'mt 4/5/2010 18:29:25'!
listMorph

	^ listMorph! !

!SwaComboBox methodsFor: 'accessing' stamp: 'mt 4/5/2010 18:29:26'!
listMorph: anObject

	listMorph := anObject.! !

!SwaComboBox methodsFor: 'initialization' stamp: 'mt 4/5/2010 18:10:51'!
listMorphClass

	^ SwaListView! !

!SwaComboBox methodsFor: 'event handling' stamp: 'mt 4/5/2010 18:43:13'!
listMouseDown: evt
	"Click outside the list."

	(self listMorph fullContainsPoint: evt position)
		ifTrue: [self listMorph selectionIndex: (self listMorph rowAtLocation: evt position)]
		ifFalse: [self hideList]! !

!SwaComboBox methodsFor: 'accessing' stamp: 'mt 4/5/2010 18:29:26'!
listSelectionIndex

	^ listSelectionIndex! !

!SwaComboBox methodsFor: 'accessing' stamp: 'mt 4/5/2010 18:44:10'!
listSelectionIndex: anInteger
	"Set the list selection."

	self hideList.
	anInteger = 0 ifTrue: [^self].
	listSelectionIndex := anInteger.
	self
		changed: #listSelectionIndex;
		updateContents;
		triggerEvent: #selectionIndex with: anInteger.
	self model ifNotNilDo: [:m | 
		self setIndexSelector ifNotNilDo: [:s |
			self useSelectionIndex
				ifTrue: [m perform: s with: anInteger]
				ifFalse: [m perform: s with: self selectedItem]]]! !

!SwaComboBox methodsFor: 'testing' stamp: 'mt 4/5/2010 18:44:38'!
listVisible
	"Answer whether the list is visible."

	^self listMorph owner notNil! !

!SwaComboBox methodsFor: 'user interface' stamp: 'mt 4/5/2010 18:44:52'!
morphicLayerNumber
	"Answer the layer number."

	^self listVisible ifTrue: [10] ifFalse: [super morphicLayerNumber]! !

!SwaComboBox methodsFor: 'user interface' stamp: 'mt 4/6/2010 19:26:11.556'!
newButtonMorph
	"Answer a new button morph"

	^(PluggableButtonMorphPlus
		on: self
		getState: nil
		action: #popList
		label: #buttonLabel)
			getEnabledSelector: nil; "#enabled;"
			label: self buttonLabel; 
			vResizing: #spaceFill;
			hResizing: #rigid;
			extent: self buttonExtent;
			cornerStyle: self cornerStyle! !

!SwaComboBox methodsFor: 'user interface' stamp: 'mt 4/5/2010 18:21:12'!
newContentMorph
	"Answer a new content morph"

	^ SwaLineEditTextMorph new
		contents: ' ';
		margins: (2@0 corner: 2@1);
		vResizing: #shrinkWrap;
		hResizing: #spaceFill;
		autoFit: false;
		lock! !

!SwaComboBox methodsFor: 'user interface' stamp: 'mt 4/6/2010 19:25:11.517'!
newListMorph
	"Answer a new list morph"

	|m|
	m := (self listMorphClass
		on: self
		list: #list
		selected: #listSelectionIndex
		changeSelected: #listSelectionIndex:
		menu: nil
		keystroke: nil)
			setProperty: #morphicLayerNumber toValue: 5;
			color: self color;
			borderStyle: BorderStyle default;
			on: #mouseDown send: #listMouseDown: to: self.
	^m! !

!SwaComboBox methodsFor: 'visibility' stamp: 'mt 4/5/2010 18:45:49'!
outOfWorld: aWorld
	"Get rid of the list if visible."

	self hideList.
	^super outOfWorld: aWorld! !

!SwaComboBox methodsFor: 'visibility' stamp: 'mt 4/5/2010 18:46:04'!
popList
	"Hide / show the list."

	"self enabled ifFalse: [^self]."
	self listMorph owner isNil
		ifTrue: [self showList]
		ifFalse: [self hideList]! !

!SwaComboBox methodsFor: 'user interface' stamp: 'mt 4/5/2010 18:46:24'!
roundedCorners: anArray
	"Set the corners to round."

	super roundedCorners: anArray.
	self buttonMorph ifNotNilDo: [:b |
		b roundedCorners: (anArray copyWithoutAll: #(1 2))]! !

!SwaComboBox methodsFor: 'accessing' stamp: 'mt 4/5/2010 18:46:46'!
selectedItem
	"Answer the selected list item."

	^(self listSelectionIndex between: 1 and: self list size) ifTrue: [
		self list at: self listSelectionIndex]! !

!SwaComboBox methodsFor: 'accessing' stamp: 'mt 4/5/2010 18:29:26'!
setIndexSelector

	^ setIndexSelector! !

!SwaComboBox methodsFor: 'accessing' stamp: 'mt 4/5/2010 18:29:26'!
setIndexSelector: anObject

	setIndexSelector := anObject.! !

!SwaComboBox methodsFor: 'visibility' stamp: 'mt 4/6/2010 19:29:11.669'!
showList
	"Show the list."

	self listMorph owner isNil
		ifTrue: [self listMorph
					bounds: (self bounds bottomLeft extent: self extent x @ self listHeight).
				self world addMorphInLayer: self listMorph.
				self changed.
				self activeHand
					newMouseFocus: self listMorph]! !

!SwaComboBox methodsFor: 'stepping' stamp: 'mt 4/5/2010 18:49:12'!
step
	"Reset mouse focus to the list if it is showing."

	self listVisible ifTrue: [
		self activeHand mouseFocus ifNil: [
			self activeHand newMouseFocus: self listMorph]]! !

!SwaComboBox methodsFor: 'stepping' stamp: 'mt 4/5/2010 18:49:26'!
stepTime
	"Answer the desired time between steps in milliseconds."

	^ 100! !

!SwaComboBox methodsFor: 'updating' stamp: 'mt 4/5/2010 18:50:11'!
update: aSymbol 
	"Refer to the comment in View|update:."

	aSymbol == getListSelector ifTrue: 
		[self updateList.
		^ self].
	aSymbol == getIndexSelector ifTrue:
		[self updateListSelectionIndex.
		^ self].! !

!SwaComboBox methodsFor: 'updating' stamp: 'mt 4/5/2010 18:51:05'!
updateContents
	"Update the contents."

	|sel|
	self contentMorph
		contents: (self listSelectionIndex > 0
			ifTrue: [sel := self list at: self listSelectionIndex.
					sel isText
						ifTrue: [sel]
						ifFalse: [sel asString]]
			ifFalse: [' ']) "needs something to keep font"! !

!SwaComboBox methodsFor: 'updating' stamp: 'mt 4/5/2010 18:51:16'!
updateList
	"Refresh the list."

	self getListSelector isSymbol ifTrue: [
		self list: (self model perform: self getListSelector).
		listSelectionIndex := 0]! !

!SwaComboBox methodsFor: 'updating' stamp: 'mt 4/5/2010 18:51:32'!
updateListSelectionIndex
	"Update the list selection."

	|i|
	self useSelectionIndex
		ifTrue: [i := self getCurrentSelectionIndex.
				listSelectionIndex == i ifTrue: [^self].
				listSelectionIndex := i]
		ifFalse: [i := self getCurrentSelection.
				listSelectionIndex := i isNil
					ifTrue: [0]
					ifFalse: [self list indexOf: i]].
	self
		changed: #listSelectionIndex;
		updateContents;
		triggerEvent: #selectionIndex with: i! !

!SwaComboBox methodsFor: 'index handling' stamp: 'mt 4/5/2010 18:51:47'!
useIndex
	"Use the model as returning the selected index rather than item."

	self useSelectionIndex: true! !

!SwaComboBox methodsFor: 'index handling' stamp: 'mt 4/5/2010 18:51:57'!
useSelection
	"Use the model as returning the selected item rather than index."

	self useSelectionIndex: false! !

!SwaComboBox methodsFor: 'accessing' stamp: 'mt 4/5/2010 18:29:26'!
useSelectionIndex

	^ useSelectionIndex! !

!SwaComboBox methodsFor: 'accessing' stamp: 'mt 4/5/2010 18:29:26'!
useSelectionIndex: anObject

	useSelectionIndex := anObject.! !

KeyedIdentitySet subclass: #OrderedKeyedIdentitySet
	instanceVariableNames: 'orderedElements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Collections'!

!OrderedKeyedIdentitySet methodsFor: 'adding' stamp: 'bs 1/21/2010 10:14'!
add: newObject
	self addIfAbsent: newObject.
	^ newObject! !

!OrderedKeyedIdentitySet methodsFor: 'adding' stamp: 'bs 1/21/2010 10:14'!
addIfAbsent: newObject
	| added |
	added := super addIfAbsent: newObject.
	added ifTrue: [ self orderedElements add: newObject ]! !

!OrderedKeyedIdentitySet methodsFor: 'accessing' stamp: 'bs 1/21/2010 10:22'!
orderedElements
	^ orderedElements ifNil: [ orderedElements := OrderedCollection ofSize: 100. ]! !

SimpleButtonMorph subclass: #SwaPushButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Widgets'!

!SwaPushButton commentStamp: 'mt 4/5/2010 14:27:26' prior: 0!
Like a simple button but with a push-effect and in serious colors.
!

!SwaPushButton class methodsFor: 'examples' stamp: 'mt 4/5/2010 14:29:52'!
example1

	(self
		label: 'Hello, World!!'
		receiver: nil
		selector: nil
		help: 'Help me!!') openInHand! !

!SwaPushButton class methodsFor: 'instance creation' stamp: 'mt 4/5/2010 14:29:01'!
label: aString receiver: anObject selector: aSymbol

	^ self
		label: aString
		receiver: anObject
		selector: aSymbol
		help: nil! !

!SwaPushButton class methodsFor: 'instance creation' stamp: 'mt 4/5/2010 17:59:42'!
label: aString receiver: anObject selector: aSymbol help: aHelpMessage

	^ self new
		label: aString;
		target: anObject;
		actionSelector: aSymbol;
		actWhen: #buttonUp;
		setBalloonText: aHelpMessage! !

!SwaPushButton methodsFor: 'accessing' stamp: 'mt 4/5/2010 14:34:20'!
actionSelector: aSymbol
	"Override to fix broken code."
	
	actionSelector := aSymbol.! !

!SwaPushButton methodsFor: 'initialization' stamp: 'mt 4/5/2010 14:20:23'!
initialize

	super initialize.
	self
		borderRaised;
		borderWidth: 2;
		color: Color gray muchLighter;
		label: 'SwaPushButton'.
		! !

!SwaPushButton methodsFor: 'events' stamp: 'mt 4/5/2010 14:21:29'!
mouseDown: event

	super mouseDown: event.
	self borderInset.! !

!SwaPushButton methodsFor: 'events' stamp: 'mt 4/5/2010 14:21:40'!
mouseUp: event

	super mouseUp: event.
	self borderRaised.! !

!MenuMorph methodsFor: '*SwaUtil' stamp: 'mt 4/8/2010 17:13:12.973'!
addLabel: label target: anObject selector: aSelector enabled: aBoolean icon: aSymbol
	"Idea extracted from ob-morphic. But ob-morphic expects anObject to implement #longDescription to provide a balloon tip."
	
	self add: label target: anObject selector: aSelector.
	self lastItem isEnabled: aBoolean.
	self lastItem icon: (MenuIcons perform: aSymbol).! !

ScrollBar subclass: #SwaGeneralScrollBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Widgets'!

!SwaGeneralScrollBar commentStamp: 'mt 12/15/2009 14:27' prior: 0!
Extracted from Polymorph. Support for GeneralScrollPane.!

!SwaGeneralScrollBar methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:45'!
setValue: newValue
	"Bypass screwed up scrollbar!!"
	
	^self perform: #setValue: withArguments: {newValue} inSuperclass: Slider! !

!SwaGeneralScrollBar methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:33'!
setValueSelector: aSymbol
	"Directly set the selector to make more flexible."
	
	setValueSelector := aSymbol! !

HashedCollection subclass: #IndexedCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Collections'!

!IndexedCollection methodsFor: 'as yet unclassified' stamp: 'bs 3/3/2010 08:03:55.665'!
add: newObject
	| index |
	newObject ifNil: [self error: 'IndexCollections cannot meaningfully contain nil as an element'].
	index := self scanFor: newObject.
	index 
		ifNil: [
			index := self scanForEmptySlot.
			self atNewIndex: index put: newObject ].
	^ index! !

!IndexedCollection methodsFor: 'as yet unclassified' stamp: 'bs 3/2/2010 11:48:14.312'!
at: index
	^ array at: index.! !

!IndexedCollection methodsFor: 'as yet unclassified' stamp: 'bs 3/2/2010 11:52:52.576'!
do: aBlock
	^ array reject: [ :ea | ea == nil ] thenDo: aBlock ! !

!IndexedCollection methodsFor: 'as yet unclassified' stamp: 'bs 3/2/2010 13:06:54.019'!
indexOf: anElement
	"Answer the index of the first occurence of anElement within the  
	receiver. If the receiver does not contain anElement, answer 0."

	^ self indexOf: anElement ifAbsent: [0]! !

!IndexedCollection methodsFor: 'as yet unclassified' stamp: 'bs 3/2/2010 13:09:14.145'!
indexOf: anObject ifAbsent: anExceptionBlock

	1 to: array size do: [ :index |
		(self matchesElement: (array at: index) with: anObject) ifTrue: [^ index]].
	^ anExceptionBlock value! !

!IndexedCollection methodsFor: 'as yet unclassified' stamp: 'bs 3/2/2010 11:56:37.03'!
matchesElement: anElement with: anObject
	^ anElement = anObject.! !

!IndexedCollection methodsFor: 'as yet unclassified' stamp: 'bs 3/2/2010 12:09:53.213'!
noCheckNoGrowFillFrom: anArray
	"Add the elements of anArray except nils to me assuming that I don't contain any of them, they are unique and I have more free space than they require."
	
	anArray withIndexDo: [ :element : index | array at: index put: element ]! !

!IndexedCollection methodsFor: 'as yet unclassified' stamp: 'bs 3/3/2010 08:10:11.32'!
remove: oldObject ifAbsent: anExceptionBlock
	| index |
	index := self scanFor: oldObject.
	index 
		ifNil: [ ^ anExceptionBlock value ]
		ifNotNil: [ 
			array at: index put: nil.
			tally := tally - 1 ].
	^ oldObject! !

!IndexedCollection methodsFor: 'as yet unclassified' stamp: 'bs 3/3/2010 08:03:47.267'!
scanFor: anObject

	| index start |
	index := start := 1.
	[ 
		(self matchesElement: (array at: index) with: anObject )
			ifTrue: [ ^index ].
		(index := index \\ array size + 1) = start ] whileFalse.
	^ nil! !

!IndexedCollection methodsFor: 'as yet unclassified' stamp: 'bs 3/2/2010 12:46:19.321'!
scanForEmptySlot
	
	| index start |
	index := start := 1.
	[ 
		((array at: index) == nil) 
			ifTrue: [ ^index ].
		(index := index \\ array size + 1) = start ] whileFalse.
	self errorNoFreeSpace! !

!IndexedCollection methodsFor: 'as yet unclassified' stamp: 'bs 3/2/2010 12:47:45.055'!
scanForEmptySlotFor2: anObject
	
	| index start |
	index := start := 1.
	[ 
		| element |
		((element := array at: index) == nil or: [ self matchesElement: element with: anObject ])
			ifTrue: [ ^index ].
		(index := index \\ array size + 1) = start ] whileFalse.
	self errorNoFreeSpace! !

!IndexedCollection methodsFor: 'as yet unclassified' stamp: 'bs 3/2/2010 12:49:11.757'!
scanForOrNil: anObject

	| index start |
	index := start := 1.
	[ 
		(self matchesElement: (array at: index) with: anObject )
			ifTrue: [ ^index ].
		(index := index \\ array size + 1) = start ] whileFalse.
	^ nil! !

IndexedCollection subclass: #IndexedIdentityCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Collections'!

!IndexedIdentityCollection methodsFor: 'as yet unclassified' stamp: 'bs 3/2/2010 12:22:04.179'!
matchesElement: anElement with: anObject
	^ anElement == anObject.! !

IdentityDictionary subclass: #OrderedKeysIdentityDictionary
	instanceVariableNames: 'orderedKeys'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Collections'!

!OrderedKeysIdentityDictionary methodsFor: 'accessing' stamp: 'bs 1/21/2010 16:03'!
at: key ifAbsentPut: aBlock
	"Return the value at the given key. 
	If key is not included in the receiver store the result 
	of evaluating aBlock as new value."

	^ self at: key ifAbsent: [
		self orderedKeys add: key.
		self at: key put: aBlock value. ]! !

!OrderedKeysIdentityDictionary methodsFor: 'accessing' stamp: 'bs 1/22/2010 10:30'!
orderedKeys
	^ orderedKeys ifNil: [ orderedKeys := OrderedIdentityCollection ofSize: 100 ]! !

!OrderedKeysIdentityDictionary methodsFor: 'accessing' stamp: 'bs 1/21/2010 13:57'!
removeKey: aKey ifAbsent: aBlock
	super removeKey: aKey ifAbsent: aBlock.
	self orderedKeys remove: aKey ifAbsent: [].! !

!OrderedKeysIdentityDictionary methodsFor: 'accessing' stamp: 'bs 1/21/2010 13:01'!
removeKeysFrom: startKey toLastAndDo: aBlock 
	| index |
	index := self orderedKeys indexOf: startKey.
	(self orderedKeys copyFrom: index to: self orderedKeys size) do: [ :eachKey | 
		self removeKey: eachKey.
		self orderedKeys remove: eachKey.
		aBlock value: eachKey ]! !

!CompiledMethod class methodsFor: '*SwaUtil' stamp: 'bs 1/3/2010 22:41'!
fromQualifiedName: aQualifiedName
	"CompiledMethod fromQualifiedName: 'Object >> #asString' "
	|substrings classname selectorString selector class|
	substrings := aQualifiedName subStrings: '>>'.
	classname := substrings first withBlanksTrimmed.
	class := (classname endsWith: ' class')
		ifTrue: [ (Smalltalk at: (classname allButLast: 6) asSymbol) class]
		ifFalse: [ Smalltalk at: classname asSymbol ].
	selectorString := substrings second withBlanksTrimmed.
	selector := (selectorString copyFrom: 2 to: selectorString size) asSymbol.
	^ class compiledMethodAt: selector.! !

!CompiledMethod methodsFor: '*SwaUtil-override' stamp: 'mt 4/14/2010 15:45:38.462'!
getSourceFor: selector in: class

	| unstyledSource styledSource |
	unstyledSource := self getUnstyledSourceFor: selector in: class.
	styledSource := SwaSourceTextStyler instance styleSource: unstyledSource of: self.
	^ styledSource.! !

!CompiledMethod methodsFor: '*SwaUtil' stamp: 'mt 4/14/2010 15:45:30.692'!
getUnstyledSourceFor: selector in: class
	"Retrieve or reconstruct the source code for this method."
	| trailer source |
	trailer := self trailer.

	trailer tempNames ifNotNil: [:namesString | 
		"Magic sources -- decompile with temp names"
		^ ((class decompilerClass new withTempNames: namesString)
				decompile: selector in: class method: self)
			decompileString].
	
	trailer sourceCode ifNotNil: [:code | ^ code ].
	
	trailer hasSourcePointer ifFalse: [
		"No source pointer -- decompile without temp names"
		^ (class decompilerClass new decompile: selector in: class method: self)
			decompileString].

	"Situation normal;  read the sourceCode from the file"
	source := [self getSourceFromFileAt: trailer sourcePointer]
				on: Error
		"An error can happen here if, for example, the changes file has been truncated by an aborted download.  The present solution is to ignore the error and fall back on the decompiler.  A more thorough solution should probably trigger a systematic invalidation of all source pointers past the end of the changes file.  Consider that, as time goes on, the changes file will eventually grow large enough to cover the lost code, and then instead of falling into this error case, random source code will get returned."
				do: [ :ex | ex return: nil].
		
	^source ifNil: [
			"Something really wrong -- decompile blind (no temps)"
			 (class decompilerClass new decompile: selector in: class method: self)
				decompileString]! !

!CompiledMethod methodsFor: '*SwaUtil' stamp: 'bs 11/20/2009 11:54'!
qualifiedName
	^ self methodClass name, ' >> #', self selector ! !

!Collection methodsFor: '*swautil' stamp: 'cs 2/19/2009 14:07'!
add: anObject ifPresent: aBlock
	"Add an object if it is absent. Else run the block"

	(self includes: anObject) 
		ifFalse: [^ self add: anObject]
		ifTrue: [^ aBlock value]! !

!Collection methodsFor: '*SwaUtil' stamp: 'bs 1/24/2010 15:42'!
flatCollect: aBlock
	^ (self collect: aBlock) flatten! !

!Collection methodsFor: '*SwaUtil' stamp: 'replica 2/28/2010 21:35:36.581'!
flatCollect: selectBlock thenDo: doBlock
	^ ((self collect: selectBlock) flatten) do: doBlock! !

!Collection methodsFor: '*SwaUtil' stamp: 'bs 1/24/2010 15:41'!
flatten
	| result |
	result := self class new.
	self do: [ :ea | result addAll: ea ].
	^ result! !

!Collection methodsFor: '*swautil' stamp: 'mt 4/22/2009 13:47'!
inject: thisValue into: binaryBlock displayingProgress: aString
	"Like inject:into: but displaying the progress of the operation."
	
	| nextValue |
	nextValue := thisValue.
	self do: [:each | nextValue := binaryBlock value: nextValue value: each] displayingProgress: aString.
	^nextValue! !

!Collection methodsFor: '*swautil' stamp: 'cs 5/22/2009 15:39'!
join: delimter
	"expects self to be collection of strings and delimter to be a string.
	returns the concatenation of the elements separeted by the delimiter"

	| stream |
	stream := WriteStream with: String new.
	self
		do: [: elem | stream nextPutAll: elem]
		separatedBy: [ stream nextPutAll: delimter].
	^ stream contents! !

!Behavior methodsFor: '*SwaUtil' stamp: 'mt 4/6/2010 15:40:09.52'!
isTestCaseClass

	^ false! !

SystemWindow subclass: #SwaDialog
	instanceVariableNames: 'contentMorph buttons cancelled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Widgets'!

!SwaDialog class methodsFor: 'constants' stamp: 'mt 4/5/2010 14:11:25'!
borderWidth

	^ 5! !

!SwaDialog class methodsFor: 'constants' stamp: 'mt 4/5/2010 19:23:34'!
defaultHeight

	^ 500! !

!SwaDialog class methodsFor: 'constants' stamp: 'mt 4/5/2010 19:23:40'!
defaultWidth

	^ 800! !

!SwaDialog methodsFor: 'control' stamp: 'mt 4/4/2010 13:01:49'!
acceptTextMorphs
	"Accept any text morphs except for those that have no edits."

	self allMorphs do: [:p |
		((p respondsTo: #accept) and: [
			(p respondsTo: #hasUnacceptedEdits) and: [
				p hasUnacceptedEdits]]) ifTrue: [p accept]]! !

!SwaDialog methodsFor: 'grips' stamp: 'mt 4/6/2010 17:53:39.339'!
addGrips
	"TODO: Add edge grips like in polymorph."

	self addCornerGrips.! !

!SwaDialog methodsFor: 'initialization' stamp: 'mt 4/5/2010 11:58:41'!
addMainPanel
	"Add the main panel."

	| panel |
	panel := self newMainPanel.
	self addMorph: panel frame: (0@0 corner: 1@1).
	
	"Fix changed apperance. See #addMorph:fullFrame:."
	panel
		color: Color transparent;
		borderWidth: 0.! !

!SwaDialog methodsFor: 'control' stamp: 'mt 4/4/2010 13:01:57'!
applyChanges
	"Apply the changes."

	self acceptTextMorphs! !

!SwaDialog methodsFor: 'accessing' stamp: 'mt 4/4/2010 12:42:22'!
buttons

	^ buttons! !

!SwaDialog methodsFor: 'accessing' stamp: 'mt 4/4/2010 12:42:22'!
buttons: anObject

	buttons := anObject.! !

!SwaDialog methodsFor: 'control' stamp: 'mt 4/4/2010 13:00:35'!
cancel
	"Cancel and close."

	self close! !

!SwaDialog methodsFor: 'accessing' stamp: 'mt 4/4/2010 13:02:45'!
cancelled

	^ cancelled! !

!SwaDialog methodsFor: 'accessing' stamp: 'mt 4/4/2010 13:02:53'!
cancelled: aBoolean

	cancelled := aBoolean! !

!SwaDialog methodsFor: 'control' stamp: 'mt 4/4/2010 13:00:28'!
close
	"Close the window."

	self delete! !

!SwaDialog methodsFor: 'accessing' stamp: 'mt 4/4/2010 12:42:44'!
contentMorph

	^ contentMorph! !

!SwaDialog methodsFor: 'accessing' stamp: 'mt 4/4/2010 12:55:08'!
contentMorph: aMorph

	contentMorph := aMorph.! !

!SwaDialog methodsFor: 'user interface helper' stamp: 'mt 4/5/2010 20:06:45'!
createCancelButton: aString

	^ SwaPushButton 
		label: aString
		receiver: self
		selector: #cancel! !

!SwaDialog methodsFor: 'user interface helper' stamp: 'mt 4/8/2010 17:28:10.563'!
createCol: someElements

	^ SwaColumnPanel for: someElements! !

!SwaDialog methodsFor: 'user interface helper' stamp: 'mt 4/8/2010 17:31:11.646'!
createHFiller

	^ SwaHFiller new! !

!SwaDialog methodsFor: 'user interface helper' stamp: 'mt 4/5/2010 14:52:33'!
createHSeparator

	^ RectangleMorph new
		vResizing: #rigid;
		hResizing: #spaceFill;
		height: 2;
		color: Color gray lighter;
		borderWidth: 1;
		borderInset! !

!SwaDialog methodsFor: 'user interface helper' stamp: 'mt 4/4/2010 12:14:56'!
createLabel: aString

	^ aString asMorph! !

!SwaDialog methodsFor: 'user interface helper' stamp: 'mt 4/5/2010 20:06:33'!
createOkButton: aString

	^ SwaPushButton 
		label: aString
		receiver: self
		selector: #ok! !

!SwaDialog methodsFor: 'user interface helper' stamp: 'mt 4/8/2010 17:28:24.912'!
createRow: someElements

	^ SwaRowPanel for: someElements! !

!SwaDialog methodsFor: 'user interface helper' stamp: 'mt 4/8/2010 17:33:38.601'!
createVFiller

	^ SwaVFiller new! !

!SwaDialog methodsFor: 'user interface helper' stamp: 'mt 4/5/2010 14:51:53'!
createVSeparator

	^ RectangleMorph new
		hResizing: #rigid;
		vResizing: #spaceFill;
		width: 2;
		color: Color gray lighter;
		borderWidth: 1;
		borderInset! !

!SwaDialog methodsFor: 'initialization' stamp: 'mt 4/5/2010 19:23:59'!
initialExtent
	"Used by World>>openModal:"
	
	^ self class defaultWidth @ self class defaultHeight! !

!SwaDialog methodsFor: 'initialization' stamp: 'mt 4/4/2010 13:03:10'!
initialize
	"Initialize the receiver."

	super initialize.
	self cancelled: true.! !

!SwaDialog methodsFor: 'accessing' stamp: 'mt 4/4/2010 12:51:20'!
model: anObject
	
	super model: anObject.
	self addMainPanel.! !

!SwaDialog methodsFor: 'initialization' stamp: 'mt 4/4/2010 12:47:51'!
newButtonRow
	"Answer a new ok/cancel button row."

	|answer e|
	e := 0@0.
	self buttons do: [:b | e := e max: b minExtent].
	self buttons do: [:b | b extent: e].
	answer := Morph new
		color: Color transparent;
		changeTableLayout;
		cellInset: 8;
		listDirection: #leftToRight;
		listCentering: #bottomRight;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap.
	self buttons do: [:b | answer addMorphBack: b].
	^answer! !

!SwaDialog methodsFor: 'initialization' stamp: 'mt 4/5/2010 10:00:17'!
newMainPanel
	"Answer a new main panel."

	^ self createCol: {
		self contentMorph.
		self newButtonRow
	}! !

!SwaDialog methodsFor: 'control' stamp: 'mt 4/4/2010 13:02:04'!
ok
	"Apply the changes and close."

	self
		cancelled: false;
		applyChanges;
		delete! !

!SwaDialog methodsFor: 'initialization' stamp: 'mt 4/5/2010 19:24:42'!
openInWorld
	"You can only resize this window after it is shown. Do this here."

	super openInWorld.
	self
		panelHeight: self class defaultHeight;
		width: self class defaultWidth.! !

!SwaDialog methodsFor: 'accessing' stamp: 'mt 4/5/2010 19:25:18'!
panelHeight

	^ self panelRect height - self class borderWidth! !

!SwaDialog methodsFor: 'accessing' stamp: 'mt 4/5/2010 19:25:27'!
panelHeight: aNumber
	"Set the height of the main panel. Add some space for the window frame."
	
	self height: aNumber + self labelHeight + (self class borderWidth * 2).! !

!SwaDialog methodsFor: 'accessing' stamp: 'mt 4/4/2010 12:52:34'!
title
	
	^ self label! !

!SwaDialog methodsFor: 'accessing' stamp: 'mt 4/4/2010 12:52:27'!
title: aString

	self setLabel: aString! !

SwaDialog subclass: #SwaInputDialog
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Widgets'!

!SwaInputDialog commentStamp: 'mt 4/5/2010 20:18:28' prior: 0!
This class provides a simple convenience dialog to get a single value from the user.

It is based on the QInputDialog class from the Qt framework.

Visit: http://doc.trolltech.com/latest/qinputdialog.html

05/04/2010 --- Only text field input implemented yet.!

!SwaInputDialog class methodsFor: 'constants' stamp: 'mt 4/5/2010 20:21:23'!
defaultHeight

	^ 110! !

!SwaInputDialog class methodsFor: 'constants' stamp: 'mt 4/5/2010 19:52:26'!
defaultWidth

	^ 300! !

!SwaInputDialog class methodsFor: 'examples' stamp: 'mt 4/5/2010 20:16:35'!
example1

	^ self getTextWithTitle: 'Example 1' label: 'Enter your name:'! !

!SwaInputDialog class methodsFor: 'instance creation' stamp: 'mt 4/16/2010 14:33:34.503'!
getTextWithTitle: aTitleString label: aLabelString

	^ self
		getTextWithTitle: aTitleString
		label: aLabelString
		value: ''! !

!SwaInputDialog class methodsFor: 'instance creation' stamp: 'mt 4/16/2010 14:32:43.09'!
getTextWithTitle: aTitleString label: aLabelString value: aDefaultValue

	| dialog |
	dialog := self new
		initializeWithTitle: aTitleString
		label: aLabelString;
		setText: aDefaultValue.
	dialog open.
	
	dialog cancelled
		ifTrue: [^ nil]
		ifFalse: [^ dialog text]! !

!SwaInputDialog methodsFor: 'user interface' stamp: 'mt 4/5/2010 20:02:27'!
createTextInput

	^ SwaLineEdit
		for: contents
		get: #contents
		set: #contents:! !

!SwaInputDialog methodsFor: 'initialization' stamp: 'mt 4/5/2010 20:16:58'!
initialize

	super initialize.
	contents := ValueHolder new contents: ''.! !

!SwaInputDialog methodsFor: 'initialization' stamp: 'mt 4/5/2010 20:15:22'!
initializeWithTitle: aTitleString label: aLabelString

	self
		buttons: {
			self createOkButton: 'Ok'.
			self createCancelButton: 'Cancel'};
		contentMorph: (self createCol: {
			(self createLabel: aLabelString) hResizing: #spaceFill.
			self createTextInput});
		model: contents;
		addGrips;
		title: aTitleString.! !

!SwaInputDialog methodsFor: 'initialization' stamp: 'mt 4/5/2010 19:53:49'!
open

	World openModal: self.! !

!SwaInputDialog methodsFor: 'accessing' stamp: 'mt 4/16/2010 14:32:18.058'!
setText: aString

	contents contents: aString.
	self changed: #contents.! !

!SwaInputDialog methodsFor: 'accessing' stamp: 'mt 4/5/2010 20:00:38'!
text

	^ contents contents! !

PluggableTextMorph subclass: #SwaLineEdit
	instanceVariableNames: 'validator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Widgets'!

!SwaLineEdit class methodsFor: 'examples' stamp: 'mt 4/5/2010 17:38:58'!
example1

	(self
		for: (ValueHolder new)
		get: #contents
		set: #contents:
		help: 'Just a dummy.') openInHand! !

!SwaLineEdit class methodsFor: 'examples' stamp: 'mt 4/8/2010 16:42:40.458'!
example2

	(self
		for: (ValueHolder new)
		get: #contents
		set: #contents:
		help: 'Just a dummy.')
		validator: #integer;
		openInHand! !

!SwaLineEdit class methodsFor: 'instance creation' stamp: 'mt 4/5/2010 20:02:17'!
for: anObject get: aGetSelector set: aSetSelector

	^ self
		for: anObject
		get: aGetSelector
		set: aSetSelector
		help: nil! !

!SwaLineEdit class methodsFor: 'instance creation' stamp: 'mt 4/5/2010 17:59:09'!
for: anObject get: aGetSelector set: aSetSelector help: aHelpMessage

	^ (self
		on: anObject
		text: aGetSelector
		accept: aSetSelector)
		setBalloonText: aHelpMessage! !

!SwaLineEdit methodsFor: 'model access' stamp: 'mt 4/8/2010 16:41:49.489'!
acceptTextInModel
	"Overridden to ensure String - not Text."
	
	| valueToAccept |
	valueToAccept := self convertedValue.
	^setTextSelector isNil or:
		[setTextSelector numArgs = 2
			ifTrue: [model perform: setTextSelector with: valueToAccept with: self]
			ifFalse: [model perform: setTextSelector with: valueToAccept]]
! !

!SwaLineEdit methodsFor: 'editing' stamp: 'mt 4/5/2010 17:17:55'!
autoAccept

	^ self textMorph autoAccept! !

!SwaLineEdit methodsFor: 'editing' stamp: 'mt 4/5/2010 17:17:47'!
autoAccept: aBoolean

	self textMorph autoAccept: aBoolean! !

!SwaLineEdit methodsFor: 'validate/convert' stamp: 'mt 4/8/2010 16:39:00.854'!
convertText

	textMorph contents: self convertedText.! !

!SwaLineEdit methodsFor: 'validate/convert' stamp: 'mt 4/8/2010 16:45:03.14'!
convertedText

	^ self convertedValue asString! !

!SwaLineEdit methodsFor: 'validate/convert' stamp: 'mt 4/8/2010 16:47:13.749'!
convertedValue

	| raw |
	raw := textMorph text asString.

	self validator = #string
		ifTrue: [^ raw].
	self validator = #integer
		ifTrue: [^ raw asInteger ifNil: [0]].
	self validator = #float
		ifTrue: [^ [(Float readFrom: raw readStream)] on: Error do: [:e | 0.0]].
		
	^ raw! !

!SwaLineEdit methodsFor: 'initialization' stamp: 'mt 4/5/2010 17:42:16'!
initialize

	super initialize.
	
	self
		hResizing: #spaceFill;
		setProperty: #noVScrollBarPlease toValue: true;
		setProperty: #noHScrollBarPlease toValue: true;
		height: 22;
		color: Color white.
	
	"Fix initial state."
	self
		setText: 'Hello, World!!';
		resizeScroller.
	
	self textMorph wrapFlag: false.! !

!SwaLineEdit methodsFor: 'scrolling' stamp: 'mt 4/5/2010 15:51:34'!
scrollByKeyboard: event 

	^false! !

!SwaLineEdit methodsFor: 'scrolling' stamp: 'mt 4/5/2010 15:51:45'!
scrollSelectionIntoView: event 
	"Scroll my text into view if necessary and return true, else return false.
	Redone here to deal with horizontal scrolling!!"
	
	| selRects delta selRect rectToTest transform cpHere |
	selectionInterval := textMorph editor selectionInterval.
	selRects := textMorph paragraph selectionRects.
	selRects isEmpty ifTrue: [^ false].
	rectToTest := selRects first merge: selRects last.
	transform := scroller transformFrom: self.
	(event notNil and: [event anyButtonPressed]) ifTrue:  "Check for autoscroll"
		[cpHere := transform localPointToGlobal: event cursorPoint.
		cpHere y <= self top
			ifTrue: [rectToTest := selRects first topLeft extent: 2@2]
			ifFalse: [cpHere y >= self bottom
					ifTrue: [rectToTest := selRects last bottomRight extent: 2@2]
					ifFalse: [^ false]]].
	selRect := transform localBoundsToGlobal: rectToTest.
	selRect height > bounds height
		ifTrue: [^ false].  "Would not fit, even if we tried to scroll"
	(delta := selRect amountToTranslateWithin: self innerBounds) ~= (0@0) ifTrue:
		["Scroll end of selection into view if necessary"
		self scrollBy: delta truncated.
		^ true].
	^ false! !

!SwaLineEdit methodsFor: 'model access' stamp: 'mt 4/8/2010 17:18:43.677'!
setText: aValue
	"Added support for converters and various types."

	super setText: aValue asString! !

!SwaLineEdit methodsFor: 'initialization' stamp: 'mt 4/5/2010 15:59:30'!
textMorphClass

	^ SwaLineEditTextMorph! !

!SwaLineEdit methodsFor: 'updating' stamp: 'mt 4/5/2010 15:23:02'!
update: aSymbol

	aSymbol == #appendEntry
		ifTrue: [^ self].
		
	super update: aSymbol.! !

!SwaLineEdit methodsFor: 'accessing' stamp: 'mt 4/8/2010 16:40:18.073'!
validator
	"Used for conversion purposes of input data. #string #integer #float"

	^ validator ifNil: [validator := #string]! !

!SwaLineEdit methodsFor: 'accessing' stamp: 'mt 4/8/2010 16:29:42.938'!
validator: aValidationMode
	"Used for conversion purposes of input data. #string #integer #float"
	
	validator := aValidationMode.! !

PluggableListMorph subclass: #SwaListView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Widgets'!

!SwaListView class methodsFor: 'instance creation' stamp: 'mt 4/5/2010 18:11:59'!
for: aModel list: listSelector selected: getSelector changeSelected: setSelector

	^ self
		for: aModel
		list: listSelector
		selected: getSelector
		changeSelected: setSelector
		help: nil! !

!SwaListView class methodsFor: 'instance creation' stamp: 'mt 4/6/2010 19:27:23.461'!
for: aModel list: listSelector selected: getSelector changeSelected: setSelector help: helpText

	^ PluggableListMorph new
"		selectionColor: self selectionColor;
		font: self listFont;"
		on: aModel
		list: listSelector
		selected: getSelector
		changeSelected: setSelector
		menu: nil
		keystroke: nil;
		autoDeselect: false;
		cornerStyle: #square;
		color: Color white;
		borderStyle: (BorderStyle inset width: 1);
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		"getEnabledSelector: nil;"
		setBalloonText: helpText! !

LayoutPolicy subclass: #SwaRowLayout
	instanceVariableNames: 'cachedMinExtent cachedMinExtents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Widgets-Support'!

!SwaRowLayout commentStamp: 'mt 4/5/2010 18:32:51' prior: 0!
Based on RowLayout from Polymorph.!

!SwaRowLayout methodsFor: 'layout' stamp: 'mt 4/5/2010 18:33:28'!
flushLayoutCache
	"Flush any cached information associated with the receiver."
	
	cachedMinExtent := nil! !

!SwaRowLayout methodsFor: 'layout' stamp: 'mt 4/5/2010 18:33:37'!
layout: aMorph in: layoutBounds
	"Compute the layout for the given morph based on the new bounds.
	Supports submorph hResizing, vResizing, cellInset, cellPositioning
	(top, *center, bottom*) and listCentering."

	|props spare fillCount extra x width height inset cell box pos vr newBounds minExt|
	aMorph submorphs ifEmpty: [^self].
	props := aMorph assureTableProperties.
	minExt := aMorph minWidth@aMorph minHeight - aMorph extent + aMorph layoutBounds extent.
	newBounds := layoutBounds origin extent: (layoutBounds extent max: minExt).
	width := 0.
	width := (self minExtentOf: aMorph in: newBounds) x.
	spare := newBounds width - width max: 0.
	fillCount := 0.
	spare > 0
		ifTrue: [fillCount := aMorph submorphs inject: 0 into: [:tot :m |
					tot + (m hResizing == #spaceFill ifTrue: [1] ifFalse: [0])].
				extra := fillCount = 0
					ifTrue: [0]
					ifFalse: [spare // fillCount].
				spare := spare - (fillCount - 1 * extra)]
		ifFalse: [extra := 0].
	x := fillCount > 0
		ifTrue: [newBounds left]
		ifFalse: [props listCentering == #center
					ifTrue: [newBounds center x - (width // 2)]
					ifFalse: [props listCentering == #bottomRight
								ifTrue: [newBounds right - width]
								ifFalse: [newBounds left]]].
	height := newBounds height.
	inset := props cellInset isPoint ifTrue: [props cellInset x] ifFalse: [props cellInset]. 
	aMorph submorphs with: cachedMinExtents do: [:m :ext |
		width := m hResizing == #spaceFill
			ifTrue: [fillCount := fillCount - 1.
					ext x + (fillCount > 0
						ifTrue: [spare]
						ifFalse: [extra])]
			ifFalse: [ext x].
		cell := x@newBounds top extent: width@height.
		((vr := m vResizing) == #shrinkWrap or: [m bounds ~= cell])
			ifTrue: [((vr == #shrinkWrap) not and: [m extent = cell extent])
						ifTrue: [m position: cell origin]
						ifFalse: [box := m bounds.
								m hResizing == #spaceFill 
									ifTrue: [box := cell origin extent: cell width @ box height].
								vr  == #spaceFill
									ifTrue: [box := box origin extent: box width @ cell height].
								vr  == #shrinkWrap
									ifTrue:[box := box origin extent: box width @ ext y].
								pos := props cellPositioning.
								box := box align: (box perform: pos) with: (cell perform: pos).
								m bounds: box]].
		x := x + width + inset]! !

!SwaRowLayout methodsFor: 'layout' stamp: 'mt 4/5/2010 18:33:48'!
minExtentOf: aMorph in: newBounds
	"Return the minimal size aMorph's children would require given the new bounds"
	
	|extent min props|
	cachedMinExtent ifNotNil: [^cachedMinExtent].
	aMorph submorphs ifEmpty: [^self].
	extent := 0@0.
	cachedMinExtents := aMorph submorphs collect: [:m |
		min := m minExtent.
		extent := extent x + min x @ (extent y max: min y).
		min].
	props := aMorph assureTableProperties.
	^cachedMinExtent := extent + (aMorph submorphs size - 1 * 
		(props cellInset isPoint ifTrue: [props cellInset x] ifFalse: [props cellInset]) @ 0)! !

!ScrollPane methodsFor: '*swautil-events' stamp: 'mt 4/16/2010 14:12:02.643'!
handlesMouseWheel: evt

	^ true! !

!ScrollPane methodsFor: '*swautil-events' stamp: 'mt 4/16/2010 14:12:16.893'!
mouseWheel: event 
	"Handle a mouseWheel event."
	
	event direction = #up ifTrue: [
		scrollBar scrollUp: 3].
	event direction = #down ifTrue: [
		scrollBar scrollDown: 3].! !

IconicButton subclass: #SwaToolButton
	instanceVariableNames: 'isCheckable checkState isAutoExclusive'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Widgets'!

!SwaToolButton commentStamp: 'mt 4/5/2010 11:20:16' prior: 0!
I am a button that can be used for toolbars.!

!SwaToolButton class methodsFor: 'instance creation' stamp: 'mt 4/5/2010 12:27:45'!
buttonGroupFor: someToolButtons orientation: aSymbol
	"Create an auto-exclusive button group like radio buttons."

	| row |
	row := Morph new
		hResizing: (aSymbol = #horizontal ifTrue: [#spaceFill] ifFalse: [#shrinkWrap]);
		vResizing: (aSymbol = #horizontal ifTrue: [#shrinkWrap] ifFalse: [#spaceFill]);
		fillStyle: Color transparent;
		changeTableLayout;
		listDirection: (aSymbol = #horizontal ifTrue: [#leftToRight] ifFalse: [#topToBottom]);
		cellInset: 8.
	
	someToolButtons do: [:button |
		button isAutoExclusive: true.
		"button hResizing: #spaceFill."
		row addMorphBack: button].
	
	^ row! !

!SwaToolButton class methodsFor: 'examples' stamp: 'mt 4/5/2010 11:22:52'!
example1

	((self
		icon: MenuIcons homeIcon
		label: 'Home'
		receiver: nil
		selector: nil)
		isCheckable: true) openInHand! !

!SwaToolButton class methodsFor: 'examples' stamp: 'mt 4/5/2010 11:44:19'!
example2

	(self buttonGroupFor: {		
		self icon: MenuIcons homeIcon label: 'Home' receiver: nil selector: nil.
		self icon: MenuIcons configurationIcon label: 'Configure' receiver: nil selector: nil.
		self icon: MenuIcons confirmIcon label: 'Confirm' receiver: nil selector: nil.
	} orientation: #vertical) openInHand! !

!SwaToolButton class methodsFor: 'instance creation' stamp: 'mt 4/5/2010 14:31:51'!
icon: aForm label: aString receiver: anObject selector: aSymbol

	^ self
		icon: aForm
		label: aString
		receiver: anObject
		selector: aSymbol
		help: nil! !

!SwaToolButton class methodsFor: 'instance creation' stamp: 'mt 4/5/2010 18:00:11'!
icon: aForm label: aString receiver: anObject selector: aSymbol help: aHelpMessage

	^ self new
		initializeWithThumbnail: aForm asMorph
		withLabel: aString
		andColor: Color white
		andSend: aSymbol
		to: anObject;
		actWhen: #buttonUp;
		actionSelector: aSymbol; "Necessary again."
		setBalloonText: aHelpMessage! !

!SwaToolButton methodsFor: 'accessing' stamp: 'mt 4/5/2010 14:34:10'!
actionSelector: aSymbol
	"Override to fix broken code."
	
	actionSelector := aSymbol.! !

!SwaToolButton methodsFor: 'accessing' stamp: 'mt 4/5/2010 10:43:04'!
checkState

	^ checkState ifNil: [checkState := #unchecked]! !

!SwaToolButton methodsFor: 'accessing' stamp: 'mt 4/5/2010 11:36:01'!
checkState: aSymbol
	"Possible values: #checked, #unchecked."
	
	checkState := aSymbol.
	self updateVisualState.
	
	((self isAutoExclusive and: [self owner notNil]) and: [aSymbol = #checked])
		ifTrue: [self owner submorphs
			select: [:m | (m isKindOf: self class) and: [m ~= self]]
			thenDo: [:m | m setChecked: false]].! !

!SwaToolButton methodsFor: 'initialization' stamp: 'mt 4/5/2010 11:12:58'!
initialize

	super initialize.
	self updateVisualState.! !

!SwaToolButton methodsFor: 'accessing' stamp: 'mt 4/5/2010 11:24:52'!
isAutoExclusive
	"Look at my owner and ensure that exactly one of my kind is checked at a time."

	^ isAutoExclusive ifNil: [isAutoExclusive := false]! !

!SwaToolButton methodsFor: 'accessing' stamp: 'mt 4/5/2010 11:29:13'!
isAutoExclusive: aBoolean

	isAutoExclusive := aBoolean.
	self isCheckable: true.! !

!SwaToolButton methodsFor: 'accessing' stamp: 'mt 4/5/2010 10:35:59'!
isCheckable

	^ isCheckable ifNil: [isCheckable := false]! !

!SwaToolButton methodsFor: 'accessing' stamp: 'mt 4/5/2010 10:35:26'!
isCheckable: anObject

	isCheckable := anObject.! !

!SwaToolButton methodsFor: 'testing' stamp: 'mt 4/5/2010 10:44:00'!
isChecked

	^ self checkState = #checked! !

!SwaToolButton methodsFor: 'events' stamp: 'mt 4/5/2010 11:08:19'!
mouseDown: event

	super mouseDown: event.
	self updateHoverEffect.! !

!SwaToolButton methodsFor: 'events' stamp: 'mt 4/5/2010 10:50:36'!
mouseEnter: event
	"Do nothing."! !

!SwaToolButton methodsFor: 'events' stamp: 'mt 4/5/2010 10:50:43'!
mouseLeave: event
	"Do nothing."! !

!SwaToolButton methodsFor: 'events' stamp: 'mt 4/5/2010 14:23:41'!
mouseMove: event
	"Do Nothing."! !

!SwaToolButton methodsFor: 'events' stamp: 'mt 4/5/2010 11:20:42'!
mouseUp: event

	super mouseUp: event.
	
	(self containsPoint: event cursorPoint)
		ifTrue: [self toggle]
		ifFalse: [self updateVisualState].! !

!SwaToolButton methodsFor: 'accessing' stamp: 'mt 4/5/2010 11:14:51'!
setChecked: aBoolean

	aBoolean
		ifTrue: [self checkState: #checked]
		ifFalse: [self checkState: #unchecked]! !

!SwaToolButton methodsFor: 'actions' stamp: 'mt 4/5/2010 11:37:50'!
toggle

	(self isAutoExclusive and: [self isChecked])
		ifTrue: [self updateVisualState. ^ self].

	self setChecked: (self isCheckable and: [self isChecked not]).! !

!SwaToolButton methodsFor: 'visual properties' stamp: 'mt 4/5/2010 11:08:06'!
updateHoverEffect

	self isChecked
		ifTrue: [self borderRaised]
		ifFalse: [self borderInset]! !

!SwaToolButton methodsFor: 'visual properties' stamp: 'mt 4/5/2010 11:03:52'!
updateVisualState

	self isChecked
		ifTrue: [self borderInset]
		ifFalse: [self borderRaised]! !

!SwaToolButton methodsFor: 'visual properties' stamp: 'mt 4/5/2010 11:03:59'!
updateVisualState: event

	self updateVisualState.! !

!String methodsFor: '*swautil-text' stamp: 'mt 6/22/2010 22:30:26.231'!
asHtmlText

	^ SwaHtmlTextFormatter toText: self! !

!String methodsFor: '*swautil' stamp: 'mt 4/28/2009 16:39'!
withoutLineEndings

	^ self withSqueakLineEndings
		copyReplaceAll: String cr
		with: ' '
		asTokens: false! !

!String methodsFor: '*swautil' stamp: 'mt 4/28/2009 16:40'!
withoutLineEndingsTruncatedTo: aNumber

	^ self withoutLineEndings truncateWithElipsisTo: aNumber! !

Object subclass: #SwaHtmlTextFormatter
	instanceVariableNames: 'offset runStack runArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Text'!

!SwaHtmlTextFormatter commentStamp: 'mt 6/22/2010 23:09:49.732' prior: 0!
I create a text instance from a given string that contains html tags for emphasis. Examples:

'Hello, <b>World!!</b>' asHtmlText
'<i>Hello</i>, World!!' asHtmlText
'<font color="#00cc00">Hello!!</font>, World!!' asHtmlText
'<font color=#FFFF00>Ahahaha!! <b>Hello</b></font>, <i><b>World</b></i>!!' asHtmlText
'<font color="#0000ff">Ahahaha!! <b><font size="7">Hello</font></b></font>, <i><b>World</b></i>!!' asHtmlText!

!SwaHtmlTextFormatter class methodsFor: 'formatting' stamp: 'mt 6/22/2010 22:28:43.544'!
toText: aString

	^ self new toText: aString! !

!SwaHtmlTextFormatter methodsFor: 'initialization' stamp: 'mt 6/22/2010 23:01:54.332'!
initialize

	super initialize.
	offset := 0.
	runStack := Stack new.
	runArray := RunArray new.
	
	runStack push: {OrderedCollection new. 1. nil. 0}.! !

!SwaHtmlTextFormatter methodsFor: 'mapping' stamp: 'mt 6/22/2010 22:58:36.294'!
mapTagToAttribute: aTag

	| rx strm result |
	aTag = '<b>' ifTrue: [^ {TextEmphasis bold}].
	aTag = '<i>' ifTrue: [^ {TextEmphasis italic}].
	aTag = '<u>' ifTrue: [^ {TextEmphasis underlined}].
	
	result := OrderedCollection new.
	
	"<font color=""#00FFCC"">"
	rx := 'color\s*=\s*"(#\w\w\w\w\w\w)' asRegex.
	strm := aTag readStream.
	[rx searchStream: strm]
		whileTrue: [ result add: (TextColor color: (Color fromString: (rx subexpression: 2)))].
		
	"<font size=""7"">"
	rx := 'size\s*=\s*"(\d+)' asRegex.
	strm := aTag readStream.
	[rx searchStream: strm]
		whileTrue: [result add:  (TextFontReference toFont: 
			(TextStyle default fontOfPointSize: (rx subexpression: 2) asInteger))].
		
	^ result! !

!SwaHtmlTextFormatter methodsFor: 'parsing' stamp: 'mt 6/22/2010 23:21:32.33'!
parseString: anHtmlString

	| tag lookForNewTag result start end attrs escapeNextCharacter |
	lookForNewTag := true.
	tag := OrderedCollection new.
	result := OrderedCollection new.
	escapeNextCharacter := false.
	
	anHtmlString withIndexDo: [:character :index |
		escapeNextCharacter
			ifTrue: [result add: character. escapeNextCharacter := false]
			ifFalse: [
				character = $\
					ifTrue: [offset := offset + 1. escapeNextCharacter := true]
					ifFalse: [
						character = $< ifTrue: [lookForNewTag := false].
						character = $> ifTrue: [lookForNewTag := true].
		
						(lookForNewTag and: [character ~= $>])
							ifTrue: [result add: character]
							ifFalse: [tag add: character. offset := offset + 1]..
			
						(tag notEmpty and: [tag last = $>]) ifTrue: [ |tmp|
							tmp := String withAll: tag.
							tmp second ~= $/
								ifTrue: [self processStartTag: tmp pos: index]
								ifFalse: [self processEndTag: tmp pos: index].			
							tag := OrderedCollection new.
							lookForNewTag := true]]]].
	
	"Add last run."
	
	"Set end index."
	runStack top at: 3 put: anHtmlString size - offset.
	
	"Write to run array."
	start := runStack top second.
	end := runStack top third.
	attrs := runStack top first.
	runArray addLast: attrs times: end - start + 1.
	
	^ String withAll: result! !

!SwaHtmlTextFormatter methodsFor: 'parsing' stamp: 'mt 6/22/2010 22:27:58.149'!
processEndTag: aTag pos: index

	|start end attrs|
	"De-Accumulate adjacent tags."
	runStack top at: 4 put: runStack top fourth - 1.
	runStack top fourth > 0
		ifTrue: [^ self "not yet"].
		
	"Set end index."
	runStack top at: 3 put: index - offset.
	
	"Write to run array."
	start := runStack top second.
	end := runStack top third.
	attrs := runStack top first.
	runArray addLast: attrs times: end - start + 1.

	runStack pop.
	runStack top at: 2 put: index - offset + 1.! !

!SwaHtmlTextFormatter methodsFor: 'parsing' stamp: 'mt 6/22/2010 22:59:18.727'!
processStartTag: aTag pos: index

	|start end attrs|
	"Accumulate adjacent tags."
	(runStack size > 1 and: [runStack top second = (index - offset + 1)])
		ifTrue: [
			runStack top at: 1 put: (runStack top first copy addAll: (self mapTagToAttribute: aTag); yourself).
			runStack top at: 4 put: (runStack top fourth + 1). "increase number of open tags"
			^self].
			
	"Set end index."
	runStack top at: 3 put: index - offset.
	"Write to run array."
	start := runStack top second.
	end := runStack top third.
	attrs := runStack top first.
	runArray addLast: attrs times: end - start + 1.
	"Remove start/end info to reuse attributes later."
	runStack top at: 2 put: nil.
	runStack top at: 3 put: nil.
	"Copy attr list and add new attr."
	runStack push: ({runStack top first copy addAll: (self mapTagToAttribute: aTag); yourself. index - offset + 1. nil. 1}).! !

!SwaHtmlTextFormatter methodsFor: 'formatting' stamp: 'mt 6/22/2010 23:21:59.959'!
toText: aString
	"Parse all known HTML attributes in the given string to text attributes."
	
	^ [Text string: (self parseString: aString) runs: runArray]
		on: Error
		do: [:e | aString asText]! !

Object subclass: #SwaListModel
	instanceVariableNames: 'list selectionIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Widgets-Support'!

!SwaListModel methodsFor: 'initialize-release' stamp: 'mt 4/6/2010 18:20:11.672'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		list: #();
		selectionIndex: 0! !

!SwaListModel methodsFor: 'accessing' stamp: 'mt 4/6/2010 18:19:28.485'!
list
	"Answer the value of list"

	^ list! !

!SwaListModel methodsFor: 'accessing' stamp: 'mt 4/6/2010 18:19:34.798'!
list: anObject
	"Set the value of list"

	list := anObject.
	self changed: #list! !

!SwaListModel methodsFor: 'accessing' stamp: 'mt 4/6/2010 18:19:42.576'!
selectedItem
	"Answer the currently selected item or nil if none."

	^self selectionIndex = 0
		ifTrue: [nil]
		ifFalse: [self list at: self selectionIndex]! !

!SwaListModel methodsFor: 'accessing' stamp: 'mt 4/6/2010 18:19:49.833'!
selectionIndex
	"Answer the value of selectionIndex"

	^ selectionIndex! !

!SwaListModel methodsFor: 'accessing' stamp: 'mt 4/6/2010 18:19:55.443'!
selectionIndex: anObject
	"Set the value of selectionIndex"

	selectionIndex := anObject.
	self changed: #selectionIndex! !

Object subclass: #SwaSourceTextStyler
	instanceVariableNames: 'registeredStylers enabled'
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'SwaUtil'!

!SwaSourceTextStyler class methodsFor: 'instance creation' stamp: 'bs 12/22/2009 10:46'!
instance
	^ Instance
		ifNil: [Instance := super new]! !

!SwaSourceTextStyler class methodsFor: 'instance creation' stamp: 'bs 12/22/2009 09:42'!
new
	"Singleton, use #instance"
	^ self error: 'Use #instance'! !

!SwaSourceTextStyler methodsFor: 'styling' stamp: 'mt 1/22/2010 12:33:34'!
disable

	enabled := false.! !

!SwaSourceTextStyler methodsFor: 'styling' stamp: 'mt 1/22/2010 12:33:28'!
enable

	enabled := true.! !

!SwaSourceTextStyler methodsFor: 'accessing' stamp: 'mt 1/22/2010 12:33:48'!
enabled

	^ enabled ifNil: [true]! !

!SwaSourceTextStyler methodsFor: 'registration' stamp: 'bs 12/22/2009 10:35'!
registerStyler: aStyler
	self registeredStylers add: aStyler! !

!SwaSourceTextStyler methodsFor: 'accessing' stamp: 'bs 12/22/2009 10:36'!
registeredStylers
	^ registeredStylers ifNil: [registeredStylers := OrderedCollection new]! !

!SwaSourceTextStyler methodsFor: 'styling' stamp: 'mt 1/22/2010 12:34:51'!
styleSource: aText of: aCompiledMethod
	
	| styledSourceText |
	self enabled ifFalse: [^ aText].
	styledSourceText := aText.
	self registeredStylers do: [ :styler | 
		styledSourceText := styler styleSource: styledSourceText of: aCompiledMethod ].
	^ styledSourceText.! !

!SwaSourceTextStyler methodsFor: 'registration' stamp: 'bs 12/22/2009 09:58'!
unregisterStyler: aStyler
	self registeredStylers remove: aStyler! !

!Morph methodsFor: '*swautil' stamp: 'SR 4/18/2009 11:25'!
allSubmorphsWith: aConditionBlock do: aBlock 
	"Evaluate the given block for all morphs in this composite morph (including the receiver)."

	submorphs do: [:m | aBlock value: m.
		(aConditionBlock value: m)
			ifTrue: [m allSubmorphsWith: aConditionBlock do: aBlock]].! !

!Morph methodsFor: '*swautil-events' stamp: 'mt 4/16/2010 13:54:05.388'!
handleMouseWheel: anEvent
	"System level event handling."
	
	anEvent wasHandled ifTrue:[^self].
	(self handlesMouseWheel: anEvent) ifTrue:[
		anEvent wasHandled: true.
		self mouseWheel: anEvent]! !

!Morph methodsFor: '*swautil-events' stamp: 'mt 4/16/2010 13:54:43.817'!
handlesMouseWheel: evt
	"Do I want to receive mouseWheel events?." 

	^false! !

!Morph methodsFor: '*swautil-events' stamp: 'mt 4/16/2010 13:55:12.273'!
mouseWheel: evt 
	"Handle a mouseWheel event."! !

!Morph methodsFor: '*swautil-testing' stamp: 'mt 10/9/2009 11:17'!
submorphOverlapsWith: anotherMorph

	self submorphs do: [:m |
		(m topLeft = anotherMorph topLeft and: [m ~= anotherMorph])
			ifTrue: [^ true]].
	^ false! !

Morph subclass: #SwaArcMorph
	instanceVariableNames: 'radius form startDegree endDegree drawInnerBorder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Widgets'!

!SwaArcMorph commentStamp: 'mt 7/8/2010 18:48:36.958' prior: 0!
Draw an arc. Be sure that the startDegree is lower than the endDegree. Cannot use magenta as color.!

!SwaArcMorph methodsFor: 'accessing' stamp: 'mt 7/8/2010 18:42:29.966'!
borderColor: aColor

	super borderColor: aColor.
	self updateForm.! !

!SwaArcMorph methodsFor: 'accessing' stamp: 'mt 7/8/2010 18:42:15.168'!
borderWidth: aNumber

	super borderWidth: aNumber.
	self updateForm.! !

!SwaArcMorph methodsFor: 'accessing' stamp: 'mt 7/8/2010 18:45:20.965'!
color: aColor

	super color: aColor.
	self updateForm.! !

!SwaArcMorph methodsFor: 'accessing' stamp: 'mt 7/8/2010 18:39:32.126'!
drawInnerBorder

	^ drawInnerBorder ifNil: [drawInnerBorder := false]! !

!SwaArcMorph methodsFor: 'accessing' stamp: 'mt 7/8/2010 18:39:52.983'!
drawInnerBorder: aBoolean

	drawInnerBorder := aBoolean.
	self updateForm.! !

!SwaArcMorph methodsFor: 'drawing' stamp: 'mt 7/8/2010 18:40:33.12'!
drawOn: aCanvas

	aCanvas
		translucentImage: form
		at: self topLeft! !

!SwaArcMorph methodsFor: 'accessing' stamp: 'mt 7/8/2010 17:09:12.567'!
endDegree

	^ endDegree ifNil: [endDegree := 0]! !

!SwaArcMorph methodsFor: 'accessing' stamp: 'mt 7/8/2010 18:39:56.806'!
endDegree: anInteger
	"0-360"
	
	endDegree := anInteger.
	self updateForm.! !

!SwaArcMorph methodsFor: 'initialization' stamp: 'mt 7/8/2010 20:05:11.437'!
initialize

	super initialize.
	
	radius := 50.
	
	self
		borderColor: Color black;
		borderWidth: 2;
		color: Color yellow;
		drawInnerBorder: true;
		startDegree: -45;
		endDegree: 45.! !

!SwaArcMorph methodsFor: 'accessing' stamp: 'mt 7/8/2010 20:03:14.987'!
radius

	^ radius! !

!SwaArcMorph methodsFor: 'accessing' stamp: 'mt 7/8/2010 20:04:15.164'!
radius: aNumber

	radius := aNumber.
	self updateForm.! !

!SwaArcMorph methodsFor: 'accessing' stamp: 'mt 7/8/2010 17:09:36.843'!
startDegree

	^ startDegree ifNil: [startDegree := 0]! !

!SwaArcMorph methodsFor: 'accessing' stamp: 'mt 7/8/2010 18:40:04.489'!
startDegree: anInteger
	"0-360"
	
	startDegree := anInteger.
	self updateForm.! !

!SwaArcMorph methodsFor: 'updating' stamp: 'mt 7/8/2010 20:05:59.251'!
updateForm

	| tmp startPt endPt mask |
	tmp := FormCanvas
		extent: self radius @ self radius * 2
		depth: 32.
		
	tmp
		fillColor: Color magenta;
		fillOval: (0@0 corner: tmp extent)
		color: self color
		borderWidth: self borderWidth
		borderColor: self borderColor.
	
	startPt := self startDegree degreeCos @ self startDegree degreeSin.
	endPt := self endDegree degreeCos @ self endDegree degreeSin.
	
	mask := OrderedCollection new.
	mask
		add: 0@0;
		add: startPt.
		
	(self startDegree to: self endDegree by: 45) do: [:degree |
		mask add: ((-1 @ -1 corner: 1@1) pointNearestTo: (degree degreeCos @ degree degreeSin) * 2)].

	mask
		add: endPt.
	
	tmp
		drawPolygon: mask * self radius + self radius
		color: Color magenta
		borderWidth: 0
		borderColor: Color transparent.
	
	(self drawInnerBorder and: [self startDegree ~= self endDegree])
		ifTrue: [
			tmp
				line: (self radius @ self radius)
				to: startPt * (self radius - 2) + self radius
				width: self borderWidth
				color: self borderColor.
		
			tmp
				line: (self radius @ self radius)
				to: endPt * (self radius - 2) + self radius
				width: self borderWidth
				color: self borderColor].
	
	form := tmp form trimBordersOfColor: Color magenta.
	form mapColor: Color magenta to: Color transparent.
	
	self
		extent: form extent;
		changed.! !

Morph subclass: #SwaGeneralScrollPane
	instanceVariableNames: 'scroller hScrollbar vScrollbar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Widgets'!

!SwaGeneralScrollPane commentStamp: 'mt 12/15/2009 14:27' prior: 0!
Extracted from Polymorph. A scroll pane that handles its contents accurately.!

!SwaGeneralScrollPane class methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:50'!
defaultScrollbarThickness

	^ Preferences scrollBarsNarrow
		ifTrue: [10]
		ifFalse: [14]! !

!SwaGeneralScrollPane methodsFor: 'accessing' stamp: 'gvc 9/28/2006 16:03'!
adoptPaneColor: paneColor
	"Adopt the given pane color."
	
	super adoptPaneColor: paneColor.
	self hScrollbar adoptPaneColor: paneColor.
	self vScrollbar adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self color: (self scrollTarget isNil
		ifTrue: [self paneColor]
		ifFalse: [self scrollTarget color])
! !

!SwaGeneralScrollPane methodsFor: 'initialization' stamp: 'gvc 9/7/2006 12:23'!
defaultColor
	"Answer the default color/fill style for the receiver."
	
	^ Color transparent! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:43'!
defaultScrollTarget
	"Answer a new default scroll target."

	^RectangleMorph new
		extent: 200@150! !

!SwaGeneralScrollPane methodsFor: 'geometry' stamp: 'gvc 9/8/2006 11:06'!
extent: newExtent
	"Update the receiver's extent. Hide/show the scrollbars and resize the scroller
	as neccessary."
	
	|scrollbarChange|
	bounds extent = newExtent ifTrue: [^ self].
	super extent: newExtent.
	scrollbarChange := (self vScrollbarShowing = self vScrollbarNeeded) not.
	scrollbarChange := scrollbarChange or: [(self hScrollbarShowing = self hScrollbarNeeded) not].
	self	updateScrollbars.
	scrollbarChange ifFalse: [self resizeScroller] "if there is a scrollbar change then done already"! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 10/3/2008 13:07'!
fitScrollTarget
	"If the scroller is bigger than the scroll target then
	resize the scroll target to fill the scroller."
	
	|extra|
	extra := 0.
	self scroller width > self scrollTarget width
		ifTrue: [self scrollTarget width: self scroller width]
		ifFalse: [extra := self scrollBarThickness].
	self scroller height - extra > self scrollTarget height
		ifTrue: [self scrollTarget height: self scroller height + extra]! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:25'!
hHideScrollbar
	"Hide the horizontal scrollbar."
	
	self hScrollbarShowing ifFalse: [^self].
	self removeMorph: self hScrollbar.
	self vResizeScrollbar.
	self resizeScroller! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:31'!
hPageDelta
	"Answer the horizontal page delta."
	
	|pd tw sw|
	tw _ self scrollTarget width.
	sw _ self scrollBounds width.
	pd _ tw - sw  max: 0.
	pd = 0 ifFalse: [pd _ sw / pd].
	^pd! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 10/3/2008 13:07'!
hResizeScrollbar
	"Resize the horizontal scrollbar to fit the receiver."
	
	|b|
	b := self innerBounds.
	b := b top: b bottom - self scrollBarThickness.
	self vScrollbarShowing ifTrue: [
		b := b right: b right - self scrollBarThickness].
	self hScrollbar bounds: b! !

!SwaGeneralScrollPane methodsFor: 'accessing' stamp: 'gvc 9/7/2006 10:16'!
hScrollbar
	"Answer the value of hScrollbar"

	^ hScrollbar! !

!SwaGeneralScrollPane methodsFor: 'accessing' stamp: 'gvc 9/7/2006 10:16'!
hScrollbar: anObject
	"Set the value of hScrollbar"

	hScrollbar := anObject! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:37'!
hScrollbarInterval
	"Answer the computed size of the thumb of the horizontal scrollbar."
	
	^self scrollBounds width asFloat / self scrollTarget width min: 1.0.! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:30'!
hScrollbarNeeded
	"Return whether the horizontal scrollbar is needed."
	
	^self scrollTarget width > self innerBounds width! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:07'!
hScrollbarShowing
	"Answer whether the horizontal scrollbar is showing."
	
	^self hScrollbar owner notNil
	! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:34'!
hScrollbarValue
	"Answer the computed horizontal scrollbar value."
	
	|tw sw v|
	tw _ self scrollTarget width.
	sw _ self scrollBounds width.
	v _ tw - sw  max: 0.
	v = 0 ifFalse: [v _  self scroller offset x asFloat / v min: 1.0].
	^v! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 10/19/2006 10:30'!
hScrollbarValue: scrollValue
	"Set the offset of the scroller to match the 0.0-1.0 scroll value."
	
	|r|
	r := self scrollTarget width - self scrollBounds width max: 0.
	self scroller
		offset: (r * scrollValue) rounded @ self scroller offset y! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:36'!
hSetScrollDelta
	"Set the horizontal scrollbar delta, value and interval, based on the current scroll bounds and offset."
	
	|pd|
	pd _ self hPageDelta.
	self hScrollbar
		scrollDelta: pd / 10 
		pageDelta: pd;
		interval: self hScrollbarInterval;
		setValue: self hScrollbarValue! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:28'!
hShowScrollbar
	"Show the horizontal scrollbar."
	
	self hResizeScrollbar.
	self hScrollbarShowing ifTrue: [^self].
	self privateAddMorph: self hScrollbar atIndex: 1.
	self vResizeScrollbar.
	self resizeScroller! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 12/9/2008 12:06'!
hUpdateScrollbar
	"Update the visibility and dimensions of the horizontal scrollbar as needed."
	
	self hScrollbarNeeded
		ifTrue: [self
					hShowScrollbar;
					hResizeScrollbar]
		ifFalse: [self hHideScrollbar]! !

!SwaGeneralScrollPane methodsFor: 'event handling' stamp: 'gvc 9/7/2006 12:16'!
handlesKeyboard: evt
	"Yes for page up/down."
	
	^true! !

!SwaGeneralScrollPane methodsFor: 'event handling' stamp: 'mt 4/16/2010 14:14:19.484'!
handlesMouseWheel: event

	^ true! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 21:11'!
hideOrShowScrollBars
	"Requested by slider. See ScrollBar>>#mouseDownInSlider:"! !

!SwaGeneralScrollPane methodsFor: 'initialization' stamp: 'gvc 9/7/2006 10:54'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		scroller: self newScroller;
		hScrollbar: self newHScrollbar;
		vScrollbar: self newVScrollbar;
		scrollTarget: self defaultScrollTarget.
	self
		addMorph: self scroller;
		resizeScroller! !

!SwaGeneralScrollPane methodsFor: 'event handling' stamp: 'gvc 9/7/2006 12:16'!
keyStroke: evt
	"If pane is not empty, pass the event to the last submorph,
	assuming it is the most appropriate recipient (!!)"

	(self scrollByKeyboard: evt) ifTrue: [^self].
	self scrollTarget keyStroke: evt! !

!SwaGeneralScrollPane methodsFor: 'event handling' stamp: 'gvc 1/28/2008 16:55'!
mouseWheel: event 
	"Handle a mouseWheel event."
	
	(self scrollTarget handlesMouseWheel: event)
		ifTrue: [^self scrollTarget mouseWheel: event]. "pass on"
	event direction = #up ifTrue: [
		vScrollbar scrollUp: 3].
	event direction = #down ifTrue: [
		vScrollbar scrollDown: 3]! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:31'!
newHScrollbar
	"Answer a new horizontal scrollbar."

	^SwaGeneralScrollBar new
		model: self;
		setValueSelector: #hScrollbarValue:! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 09:50'!
newScroller
	"Answer a new scroller."

	^TransformMorph new
		color: Color transparent! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:31'!
newVScrollbar
	"Answer a new vertical scrollbar."

	^SwaGeneralScrollBar new
		model: self;
		setValueSelector: #vScrollbarValue:! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 09:57'!
resizeScroller
	"Resize the scroller to fit the scroll bounds."
	
	self scroller bounds: self scrollBounds! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:47'!
scrollBarThickness
	"Answer the width or height of a scrollbar as appropriate to
	its orientation."
	
	^ self scrollbarThickness! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 10/3/2008 13:07'!
scrollBounds
	"Return the visible scroll area taking into account whether
	the scrollbars need to be shown."
	
	|b|
	b := self innerBounds.
	self vScrollbarNeeded ifTrue: [b := b right: (b right - self scrollBarThickness)].
	self hScrollbarNeeded ifTrue: [b := b bottom: (b bottom - self scrollBarThickness)].
	^b! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 14:07'!
scrollByKeyboard: event 
	"If event is ctrl+up/down then scroll and answer true."
	
	|sb|
	sb _ event commandKeyPressed
		ifTrue: [self hScrollbar]
		ifFalse: [self vScrollbar].
	(event keyValue = 30 or: [event keyValue = 11]) ifTrue: [
		sb scrollUp: 3.
		^true].
	(event keyValue = 31 or: [event keyValue = 12])ifTrue: [
		sb scrollDown: 3.
		^true].
	^false! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 09:48'!
scrollTarget
	"Answer the morph that is scrolled."
	
	^self scroller submorphs first! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:48'!
scrollTarget: aMorph
	"Set the morph that is scrolled."
	
	self scroller
		removeAllMorphs;
		addMorph: aMorph.
	self updateScrollbars! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 2/6/2008 10:19'!
scrollToShow: aRectangle
	"Scroll to include as much of aRectangle as possible, where aRectangle is in the scroller's local space."
	
	|offset|
	offset := self scroller offset.
	((aRectangle top - offset y) >= 0 and: [
		(aRectangle bottom - offset y) <= self innerBounds height])
		ifFalse: [offset := offset x @ (
					(aRectangle top min: self scrollTarget height - self innerBounds height))].
	((aRectangle left - offset x) >= 0 and: [
		(aRectangle right - offset x) <= self innerBounds width])
		ifFalse: [offset := (aRectangle left min: self scrollTarget width - self innerBounds width) @ offset y].
	offset = self scroller offset ifFalse: [
		self scroller offset: offset.
		self setScrollDeltas]! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:51'!
scrollbarThickness
	"Answer the width or height of a scrollbar as appropriate to
	its orientation."
	
	^ self class defaultScrollbarThickness! !

!SwaGeneralScrollPane methodsFor: 'accessing' stamp: 'gvc 9/7/2006 09:40'!
scroller
	"Answer the value of scroller"

	^ scroller! !

!SwaGeneralScrollPane methodsFor: 'accessing' stamp: 'gvc 9/7/2006 09:40'!
scroller: anObject
	"Set the value of scroller"

	scroller := anObject! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 11:16'!
setScrollDeltas
	"Set the ScrollBar deltas, value and interval, based on the current scroll pane size, offset and range."
	
	self
		hSetScrollDelta;
		vSetScrollDelta! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 11:16'!
updateScrollbars
	"Update the visibility, dimensions and values of the scrollbars as needed."
	
	self
		vUpdateScrollbar;
		hUpdateScrollbar;
		setScrollDeltas! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:25'!
vHideScrollbar
	"Hide the vertical scrollbar."
	
	self vScrollbarShowing ifFalse: [^self].
	self removeMorph: self vScrollbar.
	self hResizeScrollbar.
	self resizeScroller! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:47'!
vLeftoverScrollRange
	"Return the entire scrolling range minus the currently viewed area."
	
	^self scrollTarget height - self scrollBounds height max: 0
! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:48'!
vPageDelta
	"Answer the vertical page delta."
	
	|pd tw sw|
	tw _ self scrollTarget height.
	sw _ self scrollBounds height.
	pd _ tw - sw  max: 0.
	pd = 0 ifFalse: [pd _ sw / pd].
	^pd! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 10/3/2008 13:07'!
vResizeScrollbar
	"Resize the vertical scrollbar to fit the receiver."
	
	|b|
	b := self innerBounds.
	b := b left: b right - self scrollBarThickness.
	self hScrollbarShowing ifTrue: [
		b := b bottom: b bottom - self scrollBarThickness].
	self vScrollbar bounds: b! !

!SwaGeneralScrollPane methodsFor: 'accessing' stamp: 'gvc 9/7/2006 10:16'!
vScrollbar
	"Answer the value of vScrollbar"

	^ vScrollbar! !

!SwaGeneralScrollPane methodsFor: 'accessing' stamp: 'gvc 9/7/2006 10:16'!
vScrollbar: anObject
	"Set the value of vScrollbar"

	vScrollbar := anObject! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:48'!
vScrollbarInterval
	"Answer the computed size of the thumb of the vertical scrollbar."
	
	^self scrollBounds height asFloat / self scrollTarget height min: 1.0.! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:30'!
vScrollbarNeeded
	"Return whether the vertical scrollbar is needed."
	
	^self scrollTarget height > self innerBounds height! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:15'!
vScrollbarShowing
	"Answer whether the vertical scrollbar is showing."
	
	^self vScrollbar owner notNil
	! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:50'!
vScrollbarValue
	"Answer the computed vertical scrollbar value."
	
	|tw sw v|
	tw _ self scrollTarget height.
	sw _ self scrollBounds height.
	v _ tw - sw  max: 0.
	v = 0 ifFalse: [v _  self scroller offset y asFloat / v min: 1.0].
	^v! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 10/19/2006 10:30'!
vScrollbarValue: scrollValue
	"Set the offset of the scroller to match the 0.0-1.0 scroll value."
	
	|r|
	r := self scrollTarget height - self scrollBounds height max: 0.
	self scroller
		offset: self scroller offset x @ (r * scrollValue) rounded! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:52'!
vSetScrollDelta
	"Set the vertical scrollbar delta, value and interval, based on the current scroll bounds and offset."
	
	|pd|
	pd _ self vPageDelta.
	self vScrollbar
		scrollDelta: pd / 10 
		pageDelta: pd;
		interval: self vScrollbarInterval;
		setValue: self vScrollbarValue! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:28'!
vShowScrollbar
	"Show the vertical scrollbar."
	
	self vResizeScrollbar.
	self vScrollbarShowing ifTrue: [^self].
	self privateAddMorph: self vScrollbar atIndex: 1.
	self hResizeScrollbar.
	self resizeScroller! !

!SwaGeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:03'!
vUpdateScrollbar
	"Update the visibility and dimensions of the vertical scrollbar as needed."
	
	self vScrollbarNeeded
		ifTrue: [self
				vShowScrollbar;
				vResizeScrollbar]
		ifFalse: [self vHideScrollbar]! !

Morph subclass: #SwaPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Widgets-Support'!

!SwaPanel commentStamp: 'mt 4/8/2010 17:24:44.714' prior: 0!
This is a container for layouting purposes.!

SwaPanel subclass: #SwaColumnPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Widgets-Support'!

!SwaColumnPanel commentStamp: 'mt 4/8/2010 17:23:17.451' prior: 0!
This is a container for column-like layouting purposes.!

!SwaColumnPanel methodsFor: 'initialization' stamp: 'mt 4/8/2010 17:25:09.739'!
initialize

	super initialize.
	
	self
		hResizing: #spaceFill;
		vResizing: #spaceFill.! !

SwaPanel subclass: #SwaHFiller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Widgets-Support'!

!SwaHFiller class methodsFor: 'instance creation' stamp: 'mt 4/28/2010 11:57:45.363'!
fixed: aNumber
	
	^ self new
		hResizing: #rigid;
		width: aNumber! !

!SwaHFiller methodsFor: 'initialization' stamp: 'mt 4/28/2010 11:57:19.955'!
initialize

	super initialize.

	self
		hResizing: #spaceFill;
		height: 1.! !

!SwaPanel class methodsFor: 'instance creation' stamp: 'mt 4/8/2010 17:26:09.564'!
for: someMorphs

	^ self new
		addMorphs: someMorphs! !

!SwaPanel methodsFor: 'submorphs-add/remove' stamp: 'mt 4/8/2010 17:25:42.59'!
addMorphs: someMorphs

	someMorphs do: [:morph |
		self addMorphBack: morph].! !

!SwaPanel methodsFor: 'initialization' stamp: 'mt 4/15/2010 10:58:11.694'!
initialize

	super initialize.
	
	self
		fillStyle: Color transparent;
		changeTableLayout;
		margin: 0;
		spacing: 5.! !

!SwaPanel methodsFor: 'layout' stamp: 'mt 4/15/2010 10:57:04.778'!
margin: anInteger
	"Define the common space between panel panel border and all items."
	
	self layoutInset: anInteger.! !

!SwaPanel methodsFor: 'layout' stamp: 'mt 4/15/2010 10:53:44.598'!
spacing: anInteger
	"Define the space between panel items."
	
	self cellInset: anInteger.! !

SwaPanel subclass: #SwaRowPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Widgets-Support'!

!SwaRowPanel commentStamp: 'mt 4/8/2010 17:26:40.521' prior: 0!
This is a container for row-like layouting purposes.!

!SwaRowPanel methodsFor: 'initialization' stamp: 'mt 4/8/2010 17:27:30.2'!
initialize

	super initialize.

	self
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		listDirection: #leftToRight.! !

SwaPanel subclass: #SwaVFiller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Widgets-Support'!

!SwaVFiller class methodsFor: 'instance creation' stamp: 'mt 4/28/2010 11:58:31.277'!
fixed: aNumber
	
	^ self new
		vResizing: #rigid;
		height: aNumber! !

!SwaVFiller methodsFor: 'initialization' stamp: 'mt 4/28/2010 11:58:18.947'!
initialize

	super initialize.
	
	self
		vResizing: #spaceFill;
		width: 1.! !

Morph subclass: #SwaStackedWidget
	instanceVariableNames: 'children currentIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Widgets'!

!SwaStackedWidget methodsFor: 'add/remove' stamp: 'mt 4/5/2010 12:07:39'!
addWidget: aMorph

	self children add: aMorph.
	self currentIndex ifNil: [self currentIndex: 1].! !

!SwaStackedWidget methodsFor: 'accessing' stamp: 'mt 4/5/2010 12:04:48'!
children

	^ children ifNil: [children := OrderedCollection new]! !

!SwaStackedWidget methodsFor: 'accessing' stamp: 'mt 4/5/2010 12:07:16'!
currentIndex

	^ currentIndex! !

!SwaStackedWidget methodsFor: 'accessing' stamp: 'mt 4/5/2010 12:52:06'!
currentIndex: anInteger

	(anInteger = currentIndex
		or: [anInteger < 0
		or: [anInteger > self children size]]) ifTrue: [^ self].
	
	currentIndex := anInteger.
	
	self updateCurrentChild.! !

!SwaStackedWidget methodsFor: 'initialization' stamp: 'mt 4/5/2010 12:55:12'!
initialize

	super initialize.
	self
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		changeTableLayout;
		listDirection: #leftToRight;
		color: Color transparent.! !

!SwaStackedWidget methodsFor: 'updating' stamp: 'mt 4/5/2010 12:37:33'!
updateCurrentChild

	self currentIndex ifNil: [^ self].
	self
		removeAllMorphs;
		addMorphBack: (self children at: self currentIndex).! !

!Number class methodsFor: '*swautil-override' stamp: 'mig 4/21/2009 11:30'!
readExponent: baseValue base: base from: aStream
	"Complete creation of a number, reading exponent from aStream. Answer the
	number, or nil if parsing fails.
	<number>(e|d|q)<exponent>>"

	| sign exp value |
	('edqEDQ' includes: aStream next) ifFalse: [^ nil].
	sign := ((aStream peek) == $-)
		ifTrue: [aStream next. -1]
		ifFalse: [1].
	(aStream peek) == $+ ifTrue: [aStream next].
	(aStream atEnd or: [(aStream peek digitValue between: 0 and: 9) not])
		ifTrue: [^ nil]. "Avoid throwing an error"
	exp := (Integer readFrom: aStream base: 10) * sign.
	value := baseValue * (base raisedTo: exp).
	^ value
! !

TextMorphForEditView subclass: #SwaLineEditTextMorph
	instanceVariableNames: 'autoAccept'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Widgets-Support'!

!SwaLineEditTextMorph commentStamp: 'mt 4/5/2010 17:07:39' prior: 0!
Applied some optimizations from Polymorph.!

!SwaLineEditTextMorph methodsFor: 'accessing' stamp: 'mt 4/5/2010 17:09:34'!
autoAccept

	^ autoAccept ifNil: [autoAccept := false]! !

!SwaLineEditTextMorph methodsFor: 'accessing' stamp: 'mt 4/5/2010 17:09:20'!
autoAccept: anObject

	autoAccept := anObject.! !

!SwaLineEditTextMorph methodsFor: 'event handling' stamp: 'mt 5/2/2010 16:43:05.415'!
keyStroke: event
	"A line edit only supports one text line. Enable auto-accept if necessary."

	event keyCharacter = Character cr
		ifTrue: [(self acceptOnCR and: [self editView hasUnacceptedEdits])
			ifTrue: [self editor accept].
			^ self].
		
	super keyStroke: event.
	
	self autoAccept
		ifTrue: [self editView hasUnacceptedEdits
			ifTrue: [self editor accept]].
		
	self editView convertText.! !

!SwaLineEditTextMorph methodsFor: 'geometry' stamp: 'mt 4/5/2010 16:01:38'!
minExtent
	"gvc 10/17/2008 12:35 - TextMorphForFieldView ---
	Overridden to allow text to shrink to minimum extent rather than being (incorrectly)
	treated as rigid. Should be the same for other morphs too. Bah!!"

	| layout minExtent extra hFit vFit |
	hFit := self hResizing.
	vFit := self vResizing.
	(hFit == #spaceFill or: [vFit == #spaceFill]) 
		ifFalse: 
			["The receiver will not adjust to parents layout by growing or shrinking,
		which means that an accurate layout defines the minimum size."

			^self fullBounds extent].
	layout := self layoutPolicy.
	minExtent := layout isNil 
		ifTrue: [0 @ 0]
		ifFalse: [layout minExtentOf: self in: self layoutBounds].
	minExtent := hFit == #rigid 
		ifTrue: [self fullBounds extent x @ minExtent y]
		ifFalse: 
			[extra := self bounds width - self layoutBounds width.
			(minExtent x + extra) @ minExtent y].
	minExtent := vFit == #rigid 
				ifTrue: [minExtent x @ self fullBounds extent y]
				ifFalse: 
					[extra := self bounds height - self layoutBounds height.
					minExtent x @ (minExtent y + extra)].
	minExtent := minExtent max: self minWidth @ self minHeight.
	^minExtent! !

!SwaLineEditTextMorph methodsFor: 'geometry' stamp: 'mt 4/5/2010 16:01:56'!
minHeight
	"Answer the height of one line."

	^self minimumExtent y max: super minHeight! !

!SwaLineEditTextMorph methodsFor: 'geometry' stamp: 'mt 4/5/2010 16:02:03'!
minWidth
	"Answer the minimum width."

	^self minimumExtent x max: super minWidth! !

!SwaLineEditTextMorph methodsFor: 'geometry' stamp: 'mt 4/5/2010 16:02:16'!
minimumExtent
	"Use the actual paragraph line to take font changes into account."
	
	| minExt |
	textStyle ifNil: [^ 9@16].
	borderWidth ifNil: [^ 9@16].
	minExt := (9@(self paragraph lines first lineHeight ceiling)) + (borderWidth*2).
	margins ifNil: [^ minExt].
	^ ((0@0 extent: minExt) expandBy: margins) extent! !

!SwaLineEditTextMorph methodsFor: 'geometry' stamp: 'mt 4/5/2010 16:03:35'!
paragraph
	"Paragraph instantiation is lazy -- create it only when needed.
	Don't adjust rightX (as in TexMorph>>paragraph)
	since wrapFlag must be false for layout to work."
	
	paragraph ifNotNil: [^ paragraph].

self setProperty: #CreatingParagraph toValue: true.

	self setDefaultContentsIfNil.

	"...Code here to recreate the paragraph..."
	paragraph := (self paragraphClass new textOwner: self owner).
	paragraph wantsColumnBreaks: successor notNil.
	paragraph
		compose: text
		style: textStyle copy
		from: self startingIndex
		in: self container.
	"don't adjust the right, let it scroll!!"
	paragraph focused: (self currentHand keyboardFocus == self).
	self fit.
self removeProperty: #CreatingParagraph.

	^ paragraph! !

OrderedCollection subclass: #OrderedIdentityCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Collections'!

!OrderedIdentityCollection methodsFor: 'accessing' stamp: 'bs 1/22/2010 21:12'!
indexOf: anElement startingAt: start ifAbsent: exceptionBlock
	"Answer the index of the first occurence of anElement after start
	within the receiver. If the receiver does not contain anElement, 
	answer the 	result of evaluating the argument, exceptionBlock."

	start to: self size do:
		[:index |
		(self at: index) == anElement ifTrue: [^ index]].
	^ exceptionBlock value! !

!OrderedIdentityCollection methodsFor: 'removing' stamp: 'bs 1/22/2010 10:30'!
remove: oldObject ifAbsent: absentBlock

	| index |
	index := firstIndex.
	[index <= lastIndex]
		whileTrue: 
			[oldObject == (array at: index)
				ifTrue: 
					[self removeIndex: index.
					^ oldObject]
				ifFalse: [index := index + 1]].
	^ absentBlock value! !

!Text methodsFor: '*swautil-text' stamp: 'mt 6/22/2010 23:13:43.314'!
asHtmlText
	"No change here."
	
	^ self! !

TestCase subclass: #IndexedCollectionTests
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Collections'!

!IndexedCollectionTests methodsFor: 'running' stamp: 'bs 7/6/2010 16:55:13.465'!
setUp
	sut := IndexedCollection new.
	sut initialize: 1.! !

!IndexedCollectionTests methodsFor: 'as yet unclassified' stamp: 'bs 7/6/2010 16:53:37.513'!
testBasicOperations
	| fooIndex aFooObject aBarObject barIndex |
	aFooObject := 'foo'.
	aBarObject := 'bar'.
	
	fooIndex := sut add: aFooObject.
	self should: [ sut size = 1 ].
	self should: [ sut includes: aFooObject ].
	self should: [ aFooObject == (sut at: fooIndex) ].
	self should: [ fooIndex ==  (sut indexOf: aFooObject) ].
	
	barIndex := sut add: aBarObject.
	self should: [ sut size = 2 ].
	self should: [ sut includes: aBarObject ].
	self should: [ aBarObject == (sut at: barIndex) ].
	
	sut remove: aFooObject.
	self should: [ sut size = 1 ].
	self shouldnt: [ sut includes: aFooObject ].
	self should: [ aBarObject == (sut at: barIndex) ].
	
	sut remove: aBarObject.
	self should: [ sut size = 0 ].
	self shouldnt: [ sut includes: aBarObject ].! !

!IndexedCollectionTests methodsFor: 'as yet unclassified' stamp: 'bs 3/3/2010 08:34:05.135'!
testUsageOfFreeSpace
	| getArraySize arraySize element |
	element := ''.
	10 timesRepeat: [ element := element, 'a'. sut add: element ].
	getArraySize := [ (sut instVarNamed: 'array') size ].
	arraySize := getArraySize value.
	
	sut removeAll.
	self should: [ getArraySize value == arraySize ].
	
	10 timesRepeat: [ element := element, 'a'. sut add: element ].
	self should: [ getArraySize value == arraySize ].
! !

TestCase subclass: #IndexedIdentityCollectionTests
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Collections'!

!IndexedIdentityCollectionTests methodsFor: 'as yet unclassified' stamp: 'bs 3/2/2010 12:34:52.861'!
setUp
	sut := IndexedIdentityCollection new.
	sut initialize: 1.! !

!IndexedIdentityCollectionTests methodsFor: 'as yet unclassified' stamp: 'bs 3/2/2010 13:00:16.133'!
testForIdentitySemantic
	| fooIndex aFooObject  |
	aFooObject := 'foo'.
	
	fooIndex := sut add: aFooObject.
	self should: [ sut includes: aFooObject ].
	self should: [ aFooObject == (sut at: fooIndex) ].
	
	self should: [ fooIndex == (sut add: aFooObject) ].
	self shouldnt: [ fooIndex == (sut add: aFooObject copy) ].! !

TestCase subclass: #SwaHtmlTextFormatterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Text'!

!SwaHtmlTextFormatterTest methodsFor: 'tests' stamp: 'mt 6/22/2010 23:06:07.373'!
test01bold

	| text |
	text := '<b>Hello</b>, World!!'.
	self assert: text equals: text asHtmlText printHtmlString.! !

!SwaHtmlTextFormatterTest methodsFor: 'tests' stamp: 'mt 6/22/2010 23:06:48.692'!
test02italic

	| text |
	text := 'Hel<i>lo</i>, W<i>orl</i>d!!'.
	self assert: text equals: text asHtmlText printHtmlString.! !

!SwaHtmlTextFormatterTest methodsFor: 'tests' stamp: 'mt 6/22/2010 23:09:02.375'!
test03mixed

	| text |
	text := '<u>Ahahaha!! <b>Hello</b></u>, <i><b>World</b></i>!!'.
	self assert: text ~= text asHtmlText printHtmlString. "Bad Squeak HTML generation."! !

!SwaHtmlTextFormatterTest methodsFor: 'tests' stamp: 'mt 6/23/2010 09:04:21.741'!
test04runs

	| runs |
	runs := '<u>A<b>B</b></u>C<i><b>D</b></i>E' asHtmlText runs.
	self
		assert: 5 equals: runs size;
		assert: 1 equals: (runs at: 1) size; "underlined"
		assert: 2 equals: (runs at: 2) size; "underlined, bold"
		assert: 0 equals: (runs at: 3) size;
		assert: 2 equals: (runs at: 4) size; "italic, bold"
		assert: 0 equals: (runs at: 5) size.! !

!SwaHtmlTextFormatterTest methodsFor: 'tests' stamp: 'mt 6/23/2010 09:05:50.632'!
test05color

	| text |
	text := '<font color="#FFFF00">A</font>' asHtmlText.
	self assert: Color yellow equals: (text runs first first color)! !

!SwaHtmlTextFormatterTest methodsFor: 'tests' stamp: 'mt 6/23/2010 09:07:14.283'!
test06size

	| text |
	text := '<font size="7">A</font>' asHtmlText.
	self assert: 7 equals: (text runs first first font pointSize)! !

!SwaHtmlTextFormatterTest methodsFor: 'tests' stamp: 'mt 6/23/2010 09:08:43.464'!
test07sizeAndColor

	| text |
	text := '<font color="#FFFF00" size="7">A</font>' asHtmlText.
	self
		assert: Color yellow equals: (text runs first first color);
		assert: 7 equals: (text runs first second font pointSize)! !

!TestCase class methodsFor: '*SwaUtil' stamp: 'bs 1/15/2010 16:50'!
isTestCaseClass
	^ true! !

!TestCase class methodsFor: '*SwaUtil' stamp: 'bs 1/24/2010 15:33'!
testMethods
	^ self methodDict values select: [ :m | m isTestMethod ]! !

!Utilities class methodsFor: '*swautil-override' stamp: 'mt 1/21/2010 20:46:25'!
changeStamp 
	"Answer a string to be pasted into source code to mark who changed it and when.
	20"
	^ self authorInitials , ' ' , Date today mmddyyyy, ' ',
		((String streamContents: [:s | Time now print24: true on: s]))! !

!MouseEvent methodsFor: '*swautil-events' stamp: 'mt 4/16/2010 13:59:09.849'!
isMouseWheel

	^ false! !

MouseEvent subclass: #SwaMouseWheelEvent
	instanceVariableNames: 'direction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwaUtil-Events'!

!SwaMouseWheelEvent commentStamp: 'mt 4/16/2010 13:52:00.949' prior: 0!
Based on Polymorph mouse wheel handling.

A mouse event generated by intercepting the keyboard events (ctrl+up/down arrow) generated by the VM in response to mouse wheel activity.!

!SwaMouseWheelEvent methodsFor: 'accessing' stamp: 'mt 4/16/2010 13:52:21.616'!
direction
	^ direction! !

!SwaMouseWheelEvent methodsFor: 'accessing' stamp: 'mt 4/16/2010 13:52:21.706'!
direction: anObject
	direction := anObject! !

!SwaMouseWheelEvent methodsFor: 'testing' stamp: 'mt 4/16/2010 13:52:40.662'!
isMouseWheel

	^ true! !

!SwaMouseWheelEvent methodsFor: 'dispatching' stamp: 'mt 4/16/2010 13:54:16.355'!
sentTo: anObject
	"Dispatch the receiver into anObject"
	
	type == #mouseWheel ifTrue:[^anObject handleMouseWheel: self].
	^super sentTo: anObject.! !

!SwaMouseWheelEvent methodsFor: 'dispatching' stamp: 'mt 4/16/2010 13:54:24.836'!
setType: evtType position: evtPos direction: dirSymbol buttons: evtButtons hand: evtHand stamp: stamp
	"Set the state for the receiver."
	
	type := evtType.
	position := evtPos.
	buttons := evtButtons.
	source := evtHand.
	wasHandled := false.
	direction := dirSymbol.
	timeStamp := stamp.! !
